import java.io.*;
import java.util.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import Mailer;
import Config;

     /** A class to handle the registration servlet. */
public class RegServlet extends HttpServlet implements SingleThreadModel{

      public static String title="Congrats";
      Connection Conn;

      /* Method to initialize the servlet. */
      public void init(ServletConfig cfg) 
            throws ServletException{
                  try{
                        DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
                        Conn=DriverManager.getConnection("jdbc:oracle:thin:@everest:1521:GEN",Config.dblogin,Config.dbpassword);		
                  }catch (SQLException e){}
            }

      /** Method to process the submitted form. 
        * Checks for validity by searching from the institute database
        * and sending mail to student if valid registration has occured
        * @param req HttpServletRequest instance
        * @param res HttpServletResponse instance
        * @return Nothing
        */
      public void doPost (HttpServletRequest req,HttpServletResponse res) 
            throws ServletException, IOException {

                  res.setContentType("text/html");
                  PrintWriter out=res.getWriter();
                  Header myHeader = new Header();
                  RemoteAccess raccess=new RemoteAccess();
            
                  /* If access from allowed domain itself */
                  if(raccess.giveStatus(req,res)){ 
                    try{
                        String Message="";
                        PresentTime GetTime =new PresentTime();        

                        // get the present time for the purpose of logs.
                        Message=GetTime.gettime();

                        // extract all the parameters from the request. 
                        Enumeration values = req.getParameterNames();
                        while(values.hasMoreElements()){
                              String name=(String)values.nextElement();
                              String value=req.getParameterValues(name)[0];

                              if(name.compareTo("submit")!=0){
                                    Message+=" "+value;
                              }
                        }
                        RandGen rnum=new RandGen();
                        String passWd=rnum.generate();		

                        String sname=req.getParameterValues("sname")[0];
                        String emailadd=req.getParameterValues("semail")[0];
                        String srollnum=req.getParameterValues("sroll")[0];
                        try{
                              String Qry="SELECT SEMAIL,DNO FROM STUDENTS WHERE SROLL='"+srollnum+"'";
                              Statement Stmt=Conn.createStatement();
                              ResultSet rs=Stmt.executeQuery(Qry);
                             
                              /* if database has record of the existance of
                                 the student */
                              if(rs.next()){
                                    String e=rs.getString("SEMAIL");
                                    String dno=rs.getString("DNO");

                                    /* submitted roll number and emailid match 
                                       with those present in database 
                                       So send a mail with the password */
                                    if(e.equals(emailadd)){

                                          Qry ="INSERT INTO AUTH_TABLE VALUES('"+srollnum+"','"+passWd+"','"+dno+"','student')" ;
                                          Stmt.executeUpdate(Qry);
                                          String body="Subject:Etd Registration\n";
                                          body+="\nHello!\n";
                                          body+="You have been registered for Online Thesis Dissertation.\n";
                                          body+="\nThe details we have registered are:\n\n";
                                          body+="Email address: "+emailadd+"\n";
                                          body+="Login Id     : "+srollnum+"\n";
                                          body+="password     : " +passWd+ "\n";
                                          body+="\n\nThis is an automessage generated by"+Config.fromAdd+".\n";
                                          body+="For changing your password and other facilities, you may logon to the site:";
                                          body+=" "+Config.pubpath+"/Start.html";
                                          body+="\n\nThank you.\n";

                                          Mailer SendStudent= new Mailer(e,body);
                                          SendStudent.start();


                                          String Page="";
                                          String Title="",Head="";
                                          Title = "Online Thesis Submission";
                                          Head = "Registration Page";
                                          myHeader.printHead(Title,Head,out);
                                          Page+="<p> Congrats</p>";
                                          Page+="<p>You have been registered for Online Thesis Submission</p>";
                                          Page+=" You have given your name as: "+sname+"<br>";
                                          Page+=" You have given your email-address as: "+emailadd+"<br>";
                                          Page+=" You have given your roll number as: "+srollnum+"<br>";
                                          Page+=" Your password has been mailed to you<br>";
                                          Page+="</html>";
                                          out.println(Page);
                                          FileWriter resultsFile = new FileWriter(Config.RegLog, true);
                                          PrintWriter toFile = new PrintWriter(resultsFile);
                                          toFile.println(Message);
                                          resultsFile.close();	
                                          myHeader.printFooter(out);

                                    }

                                    /* submitted roll number and emailid dont 
                                       match with those present in database 
                                       So send a warning mail about possible
                                       misuse */
                                    else{
                                          String body="Subject:Etd Registration\n";
                                          body+=" \n\n\nWarning \n";
                                          body+=" Either you have mistyped your roll-number/emailaddress\n ";
                                          body+=" or somebody has been trying to impersonate you.\n ";
                                          body+=" In any case the channel is secure enough.\n";
                                          body+=" Re-register if U really want to.";
                                          body+=" \n\n"+Config.fromAdd;
                                          Mailer SendStudent=new Mailer(e,body);
                                          SendStudent.start();

                                          String Page="";
                                          String Title="",Head="";
                                          myHeader.printHead(Title,Head,out);
                                          Page+=" Your rollnumber does not match with the ";
                                          Page+=" corresponding email-id supplied to us ";
                                          Page+="</html>";
                                          out.println(Page);

                                          FileWriter resultsFile = new FileWriter(Config.RegFailLog, true);
                                          PrintWriter toFile = new PrintWriter(resultsFile);
                                          Message+="###Roll-email mismatch";
                                          toFile.println(Message);
                                          resultsFile.close();	
                                          myHeader.printFooter(out);
                                    }
                              }

                              /* No record of such a Student Exists ! */
                              else {

                                    String Page="";
                                    String Title="",Head="";
                                    myHeader.printHead(Title,Head,out);
                                    Page+=" The institute database has no record ";
                                    Page+=" of such an email adddress<br>";
                                    Page+=" It may also be the case that your ";
                                    Page+=" rollnumber has not yet been recorded ";
                                    Page+="</html>";
                                    out.println(Page);
                                    FileWriter resultsFile = new FileWriter(Config.RegFailLog, true);
                                    PrintWriter toFile = new PrintWriter(resultsFile);
                                    Message+="###Record not found";
                                    toFile.println(Message);
                                    resultsFile.close();	
                                    myHeader.printFooter(out);
                              } 
                         /* Handle exceptions which might occur due
                            to students trying to register twice.
                            Also catches vague SQLException exceptions
                          */  
                        }catch(SQLException e){
                              String Page="";
                              String Title="",Head="";
                              myHeader.printHead(Title,Head,out);
                              Page+="You have already been registered!!";
                              Page+="</html>";
                              out.println(Page);
                              FileWriter resultsFile = new FileWriter(Config.RegFailLog, true);
                              PrintWriter toFile = new PrintWriter(resultsFile);
                              Message+="###Registering again";
                              toFile.println(Message);
                              resultsFile.close();	
                              myHeader.printFooter(out);
                        } 

                  }catch(IOException e){
                        e.printStackTrace();
                        out.println("Error occured while writing");
                   }
                }
                
                /* Show error message if from outside IITB domain */
                else{             
                         String Page="";
                         String Title="",Head="";
                         myHeader.printHead(Title,Head,out);
                         Page+="<html>";
                         Page+="<b>Institute policies prohibit anyone";
                         Page+=" from registering from outside IITB";
                         Page+=" domain servers.</b> ";
                         Page+=" <br><b>Might also be the case that your machine";
                         Page+=" is not registered in our DNS server</b>";
                         Page+="</html>";
                         out.println(Page);
                         myHeader.printFooter(out);
                }
                  out.close();
            }
}
