import java.io.*;
import java.lang.*;
import java.lang.Math;
import java.util.*;
import java.util.Date;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import Config;
import Header;

/** A class to handle the login session of a faculty.*/
public class FacultySession extends Session{
      Header myHeader = new Header();
      String Title="",Head="";

       /** Method to print the page corresponding to various situations. 
         * @param Conn Connection instance
         * @param out PrintWriter instance
         * @param Req HttpServletRequest instance
         * @return Nothing
         */
      public void printPage(Connection Conn,PrintWriter out,HttpServletRequest Req,String cook){
            try{
                  Integer form_no = new Integer(Req.getParameterValues("form_no")[0]);
                  switch(form_no.intValue()){
                        case 0:     //welcome page for the faculty.
                              this.printUpdatePage(Conn,out);
                              break;
                        case 6:     //confirmation of thesis approval. 
                              Title = "Online Thesis Submission";
                              Head = "Confirmation";
                              myHeader.printHead(Title,Head,out);
                              this.printRespectivePage(Config.Dir+"Approval.html",out);
                              try{
                                    myHeader.printMain(out);
                                    myHeader.printPage(Config.Dir+"facultyFoot.html",out);
                                    out.println(loginId);
                                    myHeader.printPage(Config.Dir+"facultyFoot2.html",out);
                                    myHeader.printMain(out);
                                    myHeader.printPage(Config.Dir+"logout.html",out);
                                    myHeader.printFooter(out);
                              }catch(FileNotFoundException e){}
                              catch(IOException e){}
                              break;
                        case 104: // link back from home. 
                              this.printUpdatePage(Conn,out);
                              break;
                  }
            } catch(NumberFormatException e){}
            catch(FileNotFoundException e){}
            catch(IOException e){}
      }

          /** Method to print the welcome page for the faculty.
            * @param Conn Connection instance
            * @param out PrintWriter instance
            * @return Nothing
            */
      public void printUpdatePage(Connection Conn, PrintWriter out){
            String welcome="";
            ResultSet rset;
            try{
                  //extract the name of the faculty.
                  Statement stmt = Conn.createStatement();
                  String query="select fname from faculty where loginid='"+loginId+"'";
                  rset = stmt.executeQuery(query);
                  rset.next();
                  welcome = "<CENTER><H1>Welcome Prof.  "+rset.getString(1)+"</H1></CENTER>";

                  Title = "Online Thesis Submission";
                  Head = rset.getString(1)+"'s Page";
                  myHeader.printHead(Title,Head,out);

                  out.println(welcome);
                  this.printTypes(out,Conn);
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"facultyFoot.html",out);
                  out.println(loginId);
                  myHeader.printPage(Config.Dir+"facultyFoot2.html",out);
                  myHeader.printMain(out);
                  out.println("<CENTER><INPUT TYPE=HIDDEN NAME=form_no VALUE=7>");
                  out.println("<INPUT TYPE=HIDDEN NAME=login VALUE="+loginId+">");
                  out.println("<INPUT TYPE=SUBMIT VALUE=\"Update user info\">");
                  out.println("</CENTER></FORM>");
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"logout.html",out);
                  myHeader.printFooter(out);
                  out.println("</body></html>");
            }catch (SQLException e){}
            catch(IOException e){}
      }

         /** Method to print the list of various students under this prof. 
           * @param out PrintWriter instance
           * @param Conn Connection instance
           * @return Nothing 
           */
      public void printTypes(PrintWriter out,Connection Conn){
            String query,My_type;
            try{
                  Statement Stmt1=Conn.createStatement();
                  ResultSet types=Stmt1.executeQuery("select * from types");
                  String s="";
                  out.println("<CENTER><TABLE BORDER=3 BGCOLOR="+Config.tablecolor+">");
                  out.println("<TR><TD>Type of thesis</TD><TD>No. of thesis</TD><TD>Awaiting Approval</TD></TR>");
                  while(types.next()){
                        Statement Stmt2=Conn.createStatement();
                        query="select count(*) from student_faculty,student_thesis where student_faculty.loginid='"+loginId+"' and student_faculty.type='"+types.getString(1)+"' and student_faculty.sroll=student_thesis.sroll";
                        ResultSet type=Stmt2.executeQuery(query);
                        type.next();
                        if(!(type.getString(1).equals("0"))){
                              s="<TR><TD><CENTER>";
                              myHeader.printMain(out);
                              s+="<INPUT TYPE=HIDDEN NAME=type VALUE="+types.getString(1)+">";
                              s+="<INPUT TYPE=HIDDEN NAME=form_no VALUE=4> <FONT SIZE=5>";
                              My_type=types.getString(1);
                              s+="<INPUT TYPE=SUBMIT VALUE="+My_type.toUpperCase()+">";
                              s+="</FONT> </FORM>";
                              s+="</CENTER></TD><TD><CENTER>"+type.getString(1);
                              query="select count(*) from student_faculty,student_thesis,thesis where student_faculty.loginid='"+loginId+"' and student_faculty.type='"+types.getString(1)+"' and student_faculty.sroll=student_thesis.sroll and student_thesis.serialno=thesis.serialno and thesis.status!='y'";
                              ResultSet type2=Stmt2.executeQuery(query);
                              type2.next();
                              s+="</CENTER></TD><TD><CENTER>"+type2.getString(1);
                              s+="</CENTER></TD></TR>";
                              out.println(s);
                        }		    
                        Stmt2.close();
                  }
                  out.println("</TABLE></CENTER>");
            }catch(SQLException e){}
      }


           /** Method to Process the data from the corresponding form!!!
             * @param Req HttpServletRequest instance
             * @param Conn Connection instance
             * @param out PrintWriter instance
             * @return Nothing
             */
      public void processData(HttpServletRequest Req,Connection Conn,PrintWriter out){
            try{
                  Integer form_no = new Integer(Req.getParameterValues("form_no")[0]);
                  switch(form_no.intValue()){
                        case 3:     //update the information about the prof.
                              try{
                                    this.insData(Req,Conn,out);
                              }catch(SQLException e){}
                              catch(FileNotFoundException e){}
                              catch(IOException e){}
                              break;
                        case 4:     //print all the students of this type. 
                              this.search(Req,Conn,out);
                              break;
                        case 5:     //print info about this student
                              this.printStudentInfo(Req,out,Conn);
                              break;
                        case 6:     //approve thesis.
                              try{
                                    this.changeStatus(Req,Conn);
                              }catch(SQLException e){}	
                              break;
                        case 7:
                              Title = "Online Thesis Submission";
                              Head = "Update user information";
                              myHeader.printHead(Title,Head,out);
                              myHeader.printMain(out);
                              try{
                                    Statement Stmt = Conn.createStatement();
                                    String query = "select fname,femail from faculty where loginid='"+loginId+"'";
                                    ResultSet result = Stmt.executeQuery(query);
                                    result.next();
                                    myHeader.printPage(Config.Dir+"Facultyform.html",out);
                                    out.println(result.getString(1));
                                    myHeader.printPage(Config.Dir+"Facultyform2.html",out);
                                    out.println(result.getString(2));
                                    myHeader.printPage(Config.Dir+"Facultyform3.html",out);
                                    myHeader.printMain(out);
                                    myHeader.printPage(Config.Dir+"facultyFoot.html",out);
                                    out.println(loginId);
                                    myHeader.printPage(Config.Dir+"facultyFoot2.html",out);
                                    myHeader.printMain(out);
                                    myHeader.printPage(Config.Dir+"logout.html",out);
                                    myHeader.printFooter(out);
                              }catch(FileNotFoundException e){}
                              catch(IOException e){}
                              catch(SQLException e){}
                              
                  }
            } catch(NumberFormatException e){}
      }

      public void insData(HttpServletRequest Req,Connection Conn,PrintWriter out)
            throws SQLException,FileNotFoundException,IOException{
                        int newSerialNo=0;
                        Statement Stmt = Conn.createStatement();   
                        String Name=checkQuote(Req.getParameterValues("name")[0]);
                        String Email=checkQuote(Req.getParameterValues("email")[0]);
                        String Stg="update faculty set fname='"+Name+"', femail='"+Email+"' where loginid='"+loginId+"'";
                        Stmt.executeUpdate(Stg);
                        Stmt.close();
                        Title = "Online Thesis Submission";
                        Head = "Confirmation";
                        myHeader.printHead(Title,Head,out);
                        out.println("Your data has been updated successfully");
                        myHeader.printMain(out);
                        myHeader.printPage(Config.Dir+"facultyFoot.html",out);
                        out.println(loginId);
                        myHeader.printPage(Config.Dir+"facultyFoot2.html",out);
                        myHeader.printMain(out);
                        myHeader.printPage(Config.Dir+"logout.html",out);
                        myHeader.printFooter(out);
            }

          /** Method to change the status of the thesis after approval. 
            * @param Req HttpServletRequest instance
            * @param Conn Connection instance
            * @return Nothing
            */
      public void changeStatus(HttpServletRequest Req,Connection Conn)
            throws SQLException{
                  try{
                        Statement Stmt = Conn.createStatement();	
                        String Serialno=Req.getParameterValues("serialno")[0];

                        String Stg="update thesis set status='y' where serialno='"+Serialno+"'";
                        Stmt.executeUpdate(Stg);
                        Stg="select sroll from student_thesis where serialno='"+Serialno+"'";
                        ResultSet result=Stmt.executeQuery(Stg);
                        if(result.next()){
                              this.Mail(result.getString(1),Conn);
                        }
                        Stmt.close();
                  }catch(SQLException e){}
            }

           /** Open the file with name Filename and just print the
             * contents of it
             * @param Filename Name of the filename
             * @param out PrintWriter
             * @return Nothing
             */
      public void printRespectivePage(String Filename,PrintWriter out)
            throws FileNotFoundException,IOException{
                  try{
                        FileInputStream file = new FileInputStream(Filename);
                        InputStreamReader reader = new InputStreamReader(file);
                        BufferedReader input = new BufferedReader(reader);
                        String nextLine;
                        while((nextLine=input.readLine())!=null){
                              out.println(nextLine);
                        }
                        input.close();
                        reader.close();
                        file.close();
                  } catch(FileNotFoundException e){}
            }

           /** A method to search for all the students doing a thesis of
             * specified  type under this prof. 
             * @param req HttpServletRequest instance
             * @param Conn Connection instance
             * @param out PrintWriter instance
             * @return Nothing
             */
      public void search(HttpServletRequest req,Connection Conn,PrintWriter out){
            String Login,Name,Roll,Dept,Guide,Type,Title,Kw1;
            int Year;
            try{
                  Statement stmt =Conn.createStatement();
                  Login=loginId;
                  Date CurrDate=new Date();
                  Year=CurrDate.getYear()+1900;
                  Type=req.getParameterValues("type")[0];
                  String sear= "select students.sroll, students.sname, thesis.title,thesis.keyword1,thesis.keyword2,thesis.keyword3,thesis.keyword4,thesis.filename,thesis.status,thesis.serialno,thesis.abstract from student_faculty,students, thesis,student_thesis where student_faculty.sroll=students.sroll and ( student_faculty.loginid='"+Login+"' or student_faculty.co_loginid='"+Login+"') and student_faculty.type like '%"+Type+"%' and student_thesis.serialno=thesis.serialno and student_thesis.sroll=students.sroll and student_thesis.type=student_faculty.type and thesis.year='"+Year+"'";
                  ResultSet rset1=stmt.executeQuery(sear);
                  gen_form(rset1,out,Type);
            } catch(SQLException e){}
      }

         /** Method to generate the page of all the students under the page. 
           * @param res ResultSet instance
           * @param out PrintWriter instance
           * @param Type Type of the theses
           * @return Nothing
           */
      public void gen_form(ResultSet res,PrintWriter out,String Type){
            String actionString="http://"+Config.hostname;
            actionString+=":"+Config.port+"/servlet/Main";
            String sname,dname,file,dir,roll,title,filename,kw1,kw2,kw3,kw4,status;
            String serialno,str1="";
            int i=0;
            Integer i1=new Integer(0);
            Random Myrandom=new Random();
            i=Myrandom.nextInt();
            Title = "Online Thesis Submission";
            Head = "Students in "+Type.toUpperCase();
            myHeader.printHead(Title,Head,out);
            str1="<hr>";
            str1+="<center><table border=2 cellpadding=2 cellspacing=2 bgcolor='"+Config.tablecolor+"'>";
            str1+="<Caption><tr><td>Roll Number</td><td>Name</td><td>Thesis Title</td></tr></Caption>";
            try{
                  while(res.next()){
                        roll=res.getString(1);
                        sname=res.getString(2);
                        title=res.getString(3);
                        kw1=res.getString(4);
                        kw2=res.getString(5);
                        kw3=res.getString(6);
                        kw4=res.getString(7);
                        status=res.getString(9);
                        serialno=res.getString(10);
                        String Abstract=res.getString(11);
                        str1+="<form method=post action="+actionString+">";
                        str1+="<tr>";
                        str1+="<td><font size=5><input type=submit value=\""+roll+"\"></font>"+" ";
                        str1+="</center></td>";
                        str1+="<td><center><font size=5>"+sname+"</font>"+" ";
                        str1+="</center></td>";
                        str1+="<td><center><font size=5>"+title+"</font>";
                        str1+="</center></td>";
                        str1+="<input type=hidden name=form_no value=5>";
                        str1+="<input type=hidden name=roll value="+roll+">";
                        str1+="<input type=hidden name=Type value="+Type+">";
                        str1+="<input type=hidden name=title value=\""+title+"\">";
                        str1+="<input type=hidden name=kw1 value=\""+kw1+"\">";
                        str1+="<input type=hidden name=kw2 value=\""+kw2+"\">";
                        str1+="<input type=hidden name=kw3 value=\""+kw3+"\">";
                        str1+="<input type=hidden name=kw4 value=\""+kw4+"\">";
                        str1+="<input type=hidden name=serialno value=\""+serialno+"\">";
                        str1+="<input type=hidden name=Abstract value=\""+Abstract+"\">";
                        str1+="<input type=hidden name=status value=\""+status+"\">";
                        str1+="<center><font size=5>";
                        //str1+="<td><input type=submit value=\"Information regarding the thesis\"></td>";
                        str1+="</tr>";
                        str1+="</font></center></form>";
                  }
            } catch(SQLException e){} 
            str1+="</table>";
            out.println(str1);
            try{
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"facultyFoot.html",out);
                  out.println(loginId);
                  myHeader.printPage(Config.Dir+"facultyFoot2.html",out);
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"logout.html",out);
                  myHeader.printFooter(out);
            }catch(FileNotFoundException e){}
            catch(IOException e){}
            out.println("</body></html>");
      }


         /** Method to print the info about a particular student. 
           * @param req HttpServletRequest instance
           * @param out PrintWriter instance
           * @param Conn Connection instance
           * @return Nothing
           */
      public void printStudentInfo(HttpServletRequest req,PrintWriter out,Connection Conn){
            try{
                  String dno="",year="",serialno="";
                  String thesisDir=Config.thesissite;
                  Statement Stmt=Conn.createStatement();
                  String actionString="http://"+Config.hostname;
                  actionString+=":"+Config.port+"/servlet/Main";
                  Title = "Online Thesis Submission";
                  Head = "Students Information";
                  myHeader.printHead(Title,Head,out);
                  String roll=req.getParameterValues("roll")[0];
                  String type=req.getParameterValues("Type")[0];
                  String Stg="select dno from auth_table where login='"+roll+"'";
                  ResultSet Dno=Stmt.executeQuery(Stg); 
                  if(Dno.next()){
                        dno=Dno.getString(1);
                  }	
                  Stg="select serialno from student_thesis where sroll='"+roll+"'and type='"+type+"'";
                  ResultSet Result=Stmt.executeQuery(Stg);
                  if(Result.next()){
                        serialno=Result.getString(1);
                  }
                  Stg="select year from thesis where serialno='"+serialno+"'";
                  ResultSet Year=Stmt.executeQuery(Stg); 
                  if(Year.next()){
                        year=Year.getString(1);
                  }	
                  String str1="<form method=post action="+actionString+">";
                  str1+="<center>";
                  str1+="<font size=5>";
                  str1+="<br> Student Roll No :"+req.getParameterValues("roll")[0];
                  str1+="<br> Thesis Type : "+req.getParameterValues("Type")[0];
                  str1+="<br> Title of Thesis : "+req.getParameterValues("title")[0];
                  str1+="<br> Key words : "+req.getParameterValues("kw1")[0]+","+req.getParameterValues("kw2")[0]+","+req.getParameterValues("kw3")[0]+","+req.getParameterValues("kw4")[0];
                  String file=thesisDir+"/"+dno+"/"+year+"/"+type+"/"+roll+".html";
                  str1+="<br><a href=\""+file+"\"> Thesis</a><br>";
                  str1+="<input type=hidden name=form_no value=6>";
                  str1+="<input type=hidden name=serialno value="+req.getParameterValues("serialno")[0]+">";
                  str1+="<u>Abstract of the thesis</u><br>"+req.getParameterValues("Abstract")[0]+"<br>";
                  String status=req.getParameterValues("status")[0];
                  if(status.compareTo("y") != 0){
                        str1+="<input type=submit value=\"Approve thesis\">";
                  }
                  str1+="</font></center></form>";
                  out.println(str1);
                  try{
                        myHeader.printMain(out);
                        myHeader.printPage(Config.Dir+"facultyFoot.html",out);
                        out.println(loginId);
                        myHeader.printPage(Config.Dir+"facultyFoot2.html",out);
                        myHeader.printMain(out);
                        myHeader.printPage(Config.Dir+"logout.html",out);
                        myHeader.printFooter(out);
                  }catch(FileNotFoundException e){}
                  catch(IOException e){}
                  out.println("</body></html>");
            } catch(SQLException e){}
      }

       /** Use for mailing the faculty about the submission of thesis 
         * by a student under him.
         * @param rollno Roll number of studnt
         * @param con Connection instance
         * @return Nothing
         */
      void Mail(String rollno,Connection con){
            try{
                  Statement stmt=con.createStatement();
                  String str="select students.semail,faculty.fname,students.sname from faculty,students,student_faculty where students.sroll=student_faculty.sroll and faculty.loginid=student_faculty.loginid and students.sroll='"+rollno+"'";

                  /* finding the email address and name of the guide and coguide given the
                   rollno of the student.*/

                  ResultSet rset1=stmt.executeQuery(str);
                  while(rset1.next()){
                        String semail=rset1.getString(1);
                        String fname=rset1.getString(2);
                        String sname=rset1.getString(3);
                        String body="Mr/Mrs. "+sname+",\n\nCongratulation. Your thesis has";
                        body+=" been approved by Prof. "+fname+".";

                        Mailer student=new Mailer(semail,body);
                        student.start();
                  }
            }catch(SQLException e){}
      }	

      String checkQuote(String initString){
            int beginindex=0,endindex=0;
            String returnString="";
            for(;;){
                  endindex=initString.indexOf("'",beginindex);
                  if(endindex==-1){
                        returnString+=initString.substring(beginindex);
                        break;
                  } 
                  else{
                        returnString+=initString.substring(beginindex,endindex)+"''";
                        beginindex=endindex+1;
                  } 
            }   
            return(returnString);
      } 

}
