import java.io.*;
import java.lang.*;
import java.util.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import Mailer;

        /** A class to handle the group mailing facility of the root. 
         * The root can send a group mail to all the students doing a 
         * thesis of a  particular type.
         */
        
public class GroupMailer{

      /** A method to send the mail. 
        * Method sends mail to all recipients of a particular group.
        * @param type  whether btp/seminar/dissertation
        * @param body  the body of mail
        * @param Conn  the connection
        * @param out   Instance of PrintWriter
        * @return Nothing 
        */
      public void Start(String type,String body,Connection Conn,PrintWriter out) 
            throws ServletException, IOException {
            Header myHeader = new Header();

            try{
                  String Qry="SELECT SEMAIL ";
                  Qry+="FROM STUDENTS,STUDENT_THESIS ";
                  Qry+="WHERE STUDENTS.SROLL=STUDENT_THESIS.SROLL";
                  if(!(type.equals("All"))) {
                        Qry+= "AND TYPE='"+type+"'";
                  }
                  Statement Stmt=Conn.createStatement();
                  ResultSet rs=Stmt.executeQuery(Qry);
                  String Page="";

                  String Title = "Online Thesis Submission";
                  String Head = "Mail System";
                  myHeader.printHead(Title,Head,out);

                  while(rs.next()){
                        String e=rs.getString("SEMAIL");
                        Mailer SendStudent= new Mailer(e,body);
                        SendStudent.start();                // send the mail. 
                        Page="Mail being sent to "+e;
                        out.println(Page);
                  }
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"rootFoot.html",out);
                  myHeader.printFooter(out);
            }
            catch(SQLException e){
                  String Page="<html>";
                  Page+=" Could not send mail";
                  Page+="</html>";
                  out.println(Page);
            }
      }
}

