import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.util.Date;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import Config;

            /** A class for HTML generation. 
              * This is used for generating Headers of a Page.
              * Obviously this reduces coding in the other Servlets,
              * improves readability and provides some informity in
              * the generated web pages.
              */
public class Header{

            /** Method to print the header of a page.  
              * @param intitle Title of the page
              * @param head Part of the Page to be inserted between HEAD tags
              * @param out PrintWriter instance
              * @return Nothing
              */
      public void printHead(String intitle,String head,PrintWriter out){
            String title="Online thesis Submission";
            String s="<HTML> <TITLE>"+title+"</TITLE>";
            s+="<BODY TEXT="+Config.text+" BGCOLOR="+Config.bgcolor+" LINK="+Config.link+">";
            s+="<HEAD><CENTER><H1><U>"+head+"</U></H1></CENTER></HEAD>";
            out.println(s);
      }

            /** Methods are used for printing ACTION on `Main` servlet.
              * @param out PrintWriter
              * @return Nothing
              */
      public void printMain(PrintWriter out){
            String s;
            s="<FORM METHOD=POST ACTION=\"http://"+Config.hostname+":";
            s+=Config.port+"/servlet/Main\">";
            out.println(s);
      }
            /** Methods are used for printing ACTION on `Register` servlet.
              * @param out PrintWriter
              * @return Nothing
              */
      public void printRegister(PrintWriter out){
            String s;
            s="<form method=post action=\"http://"+Config.hostname+":";
            s+=Config.port+"/servlet/Register\">";
            out.println(s);
      }
            /** Methods are used for printing ACTION on `Query` servlet.
              * @param out PrintWriter
              */
      public void printQuery(PrintWriter out){
            String s;
            s="<FORM METHOD=POST ACTION=\"http://"+Config.hostname+":";
            s+=Config.port+"/servlet/Query\">";
            out.println(s);
      }
            /** Methods are used for printing ACTION on `Stat` servlet.
              * @param out PrintWriter
              * @return Nothing
              */
      public void printStat(PrintWriter out){
            String s;
            s="<FORM METHOD=POST ACTION=\"http://"+Config.hostname+":";
            s+=Config.port+"/servlet/Stat\">";
            out.println(s);
      }
            /** Methods are used for printing ACTION on `rootChangedPassword` servlet.
              * @param out PrintWriter
              * @return Nothing
              */
      public void printrcp(PrintWriter out){
            String s;
            s="<FORM METHOD=POST ACTION=\"http://"+Config.hostname+":";
            s+=Config.port+"/servlet/rootChangedPassword\">";
            out.println(s);
      }
            /** Methods are used for printing ACTION on `ChangePasswd` servlet.
              * @param out PrintWriter
              * @return Nothing
              */
      public void printcp(PrintWriter out){
            String s;
            s="<FORM METHOD=POST ACTION=\"http://"+Config.hostname+":";
            s+=Config.port+"/servlet/ChangePasswd\">";
            out.println(s);
      }

            /** Methods are used for printing ACTION on `GroupMail` servlet.
              * @param out PrintWriter
              * @return Nothing
              */
      public void printGroupMail(PrintWriter out){
            String s;
            s="<FORM METHOD=POST ACTION=\"http://"+Config.hostname+":";
            s+=Config.port+"/servlet/GroupMail\">";
            out.println(s);
      }

            /** Method to print a specified html file on to the specified printwriter.
              * @param Filename The .html file  from which PrintWriter extracts
              * @param out PrintWriter instance
              * @return Nothing
              */
      public void printPage(String Filename,PrintWriter out) throws FileNotFoundException,IOException{
            try{
                  FileInputStream file = new FileInputStream(Filename);
                  InputStreamReader reader = new InputStreamReader(file);
                  BufferedReader input = new BufferedReader(reader);
                  String nextLine;
                  while((nextLine=input.readLine())!=null){
                        out.println(nextLine);
                  }
                  input.close();
                  reader.close();
                  file.close();
            } catch(FileNotFoundException e){}
      }

             /** A method for printing footer on each page.
               * @param out PrintWriter
               * @return Nothing
               */
      public void printFooter(PrintWriter out) {
            out.println("<HR> <CENTER> <TABLE> <TR><TD>");
            this.printMain(out);
            out.println("<INPUT TYPE=hidden NAME=form_no VALUE=202> <INPUT TYPE=submit VALUE=Register>");
            out.println("</FORM> </TD><TD>");

            this.printMain(out);
            out.println("<INPUT TYPE=hidden NAME=form_no VALUE=201> <INPUT TYPE=submit VALUE=Login>");
            out.println("</FORM> </TD><TD>");

            this.printQuery(out);
            out.println("<INPUT TYPE=HIDDEN NAME=form_no VALUE=0><INPUT TYPE=SUBMIT VALUE=Search></FORM></TD><TD>");

            this.printStat(out);
            out.println("<INPUT TYPE=HIDDEN NAME=form_no VALUE=0>");
            out.println("<INPUT TYPE=SUBMIT VALUE=Statistics></FORM></TD><TD>");

            this.printMain(out);
            out.println("<INPUT TYPE=SUBMIT VALUE='Change Password'>");
            out.println("<INPUT TYPE=HIDDEN NAME=form_no VALUE=100>");
            out.println("</FORM></TD>");
            out.println("</TR></TABLE> </CENTER>");

            String mainPage="Click <a href="+Config.pubpath+"/Start.html>Here</a> to go to the main page";
            out.println(mainPage);
      }
}
