import java.io.*; 
import java.util.*; 
import java.sql.*; 
import javax.servlet.*; 
import javax.servlet.http.*; 
import Config; 
import Header;

          /** Class to handle the various querries and output the
            * result of the querries
            */
public class QuerySession extends SearchSession{
      Connection Conn;
      Header myHeader = new Header();
      String Title="",Head="";

      public QuerySession(Connection Conn){
            this.Conn = Conn;
      }	

           /** Method to process the querries being posted from a form.
             * @param Req HttpServletRequest instance
             * @param Conn Connection instance
             * @param out PrintWriter instance
             * @return Nothing
             */
      public void processData(HttpServletRequest Req,Connection Conn,PrintWriter out){
            try{
                  Integer form_no = new Integer(Req.getParameterValues("form_no")[0]);
                  switch(form_no.intValue()){
                        case 0:
                              try{	
                                    Title = "Online Thesis Submission";
                                    Head = "Query Form";
                                    myHeader.printHead(Title,Head,out);
                                    myHeader.printQuery(out);
                                    this.printRespectivePage("Queries1.html",out);	
                                    this.printTypes(out);
                                    this.printRespectivePage("Queries2.html",out);	
                                    myHeader.printFooter(out);
                                    myHeader.printMain(out);
                                    out.println("</BODY></HTML>");
                              } catch(FileNotFoundException e){}
                              catch(IOException e){}
                              break;
                        case 1:
                              this.search(out,Req);
                              break;
                        case 2:
                              this.printStudentInfo(Req,out,Conn);
                              break;
                  }
            } catch(NumberFormatException e){}
      }
              
             /** Method to print the select Buttons for various types of submissions
               * @param out PrintWriter
               * @return Nothing
               */
      public void printTypes(PrintWriter out){
            try{
                  Statement Stmt=Conn.createStatement();
                  ResultSet types=Stmt.executeQuery("select * from types");
                  String s="<tr><td> <font size=5> Thesis Type </font> </td><td>";
                  s+="<font size=5><select name=\"ttype\"><option selected value=\"\">None";
                  while(types.next()){
                        s+="<option value=\""+types.getString(1)+"\">"+types.getString(1);
                  }
                  s+="</select><br></font></td></tr>";
                  out.println(s);
            } catch(SQLException e){}
      }
           
              /** Method to search for a particular tuple
                * This searches for a particular student's name,roll number
                * department,thesis type,etc along with the faculty member
                * associated with him. Also prints the various tuples of
                * the faculty member associated with the student
                * @param out PrintWriter instance
                * @param req HttpServletRequest instance
                * @return Nothing
                */

      public void search(PrintWriter out, HttpServletRequest req){
            String Name,Roll,Dept,Guide,Year,Type,Title,Kw1;
            try{
                  String query="";
                  Statement stmt =Conn.createStatement();
                  Name=req.getParameterValues("name")[0];
                  Roll=req.getParameterValues("rollno")[0];
                  Dept=req.getParameterValues("dept")[0];
                  Guide=req.getParameterValues("gname")[0];
                  Year=req.getParameterValues("year")[0];
                  Type=req.getParameterValues("ttype")[0];
                  Kw1=req.getParameterValues("keyword1")[0];
                  Title=req.getParameterValues("title")[0];
                  
                  query = "<P>You searched for:<BR>Name='"+Name+"'   Roll no='"+Roll+"'   Department='"+Dept+"'   Guide='"+Guide+"'   Year='"+Year+"'   Type of thesis='"+Type+"'   Keyword='"+Kw1+"'   Title of thesis='"+Title+"'<BR>";
                  String sear="select students.sroll, students.sname,students.saddress,students.semail,department.dname, thesis.title,thesis.type,thesis.filename, faculty.fname,faculty.femail,thesis.abstract,thesis.status from thesis,student_thesis,students,faculty,department,student_faculty where thesis.title like '%"+ Title +"%' and (keyword1 like '%"+ Kw1+"%' or keyword2 like '%"+Kw1+"%' or keyword3 like '%"+Kw1+"%' or Keyword4 like '%"+Kw1+"%') and thesis.year like '%"+Year+"%' and thesis.type like '%"+Type+"%' and (faculty.fname like '%"+Guide+"%' or faculty.loginid like '%"+Guide+"%') and (department.dno like '%"+Dept+"%' or department.dname like '%"+Dept+"%') and students.sname like '%"+Name+"%' and students.sroll like '%"+Roll+"%' and thesis.serialno=student_thesis.serialno and student_thesis.sroll=students.sroll and student_faculty.sroll=student_thesis.sroll and student_faculty.loginid=faculty.loginid and students.dno=department.dno and student_thesis.type=thesis.type and student_faculty.type=thesis.type"; 
                  ResultSet rset1=stmt.executeQuery(sear);
                  gen_form(rset1,out,query);
            } catch(SQLException e){}
      }
            /** Method to generate the form associated with the student query
              * of above method.
              * @param res ResultSet instance
              * @param out PrintWriter instance
              * @param query Query String 
              * @return Nothing
              */
      public void gen_form(ResultSet res,PrintWriter out,String query){
            String sname,fname,dname,file,dir,address,email,roll,type,title,filename;
            String thesisDir=Config.thesispath;
            Title = "Online Thesis Submission";
            Head = "Search Results";
            myHeader.printHead(Title,Head,out);
            out.println(query);
            String str1="";
            int i=0;
            Integer i1=new Integer(0);
            Random Myrandom = new Random();
            i=Myrandom.nextInt();
            try{
                  while(res.next()){
                        roll=res.getString(1);
                        sname=res.getString(2);
                        address=res.getString(3);
                        email=res.getString(4);
                        dname=res.getString(5);
                        title=res.getString(6);
                        type=res.getString(7);
                        fname=res.getString(9);
                        String Abstract=res.getString(11);
                        String status=res.getString(12);
                        myHeader.printQuery(out);
                        str1="<hr><font size=5>";
                        str1+="<center>"+sname+","+title+","+type+"</center><br>";
                        str1+="<input type=hidden name=roll value=\""+roll+"\">";
                        str1+="<input type=hidden name=address value=\""+address+"\">";
                        str1+="<input type=hidden name=fname value=\""+fname+"\">";
                        str1+="<input type=hidden name=Abstract value=\""+Abstract+"\">";
                        str1+="<input type=hidden name=email value=\""+email+"\">";
                        str1+="<input type=hidden name=sname value=\""+sname+"\">";
                        str1+="<input type=hidden name=dname value=\""+dname+"\">";
                        str1+="<input type=hidden name=Type value=\""+type+"\">";
                        str1+="<input type=hidden name=status value=\""+status+"\">";
                        str1+="<input type=hidden name=title value=\""+title+"\">";
                        str1+="<input type=hidden name=form_no value=2>";
                        str1+="<center><input type=submit value=\"Information regarding the Student\">";
                        str1+="</center></font></form>";
                        out.println(str1);
                  }
                  myHeader.printFooter(out);
                  out.println("</body></html>");
            } catch(SQLException e){} 
      }

            /** Method to actually print the student information after processing 
              * the query from the methods above
              * @param req HttpServletRequest instance
              * @param out PrintWriter instance
              * @param Conn Connection instance
              * @return Nothing
              */
      public void printStudentInfo(HttpServletRequest req,PrintWriter out,Connection Conn){
            try{
                  Statement Stmt=Conn.createStatement();
                  String thesisDir=Config.thesissite;
                  String dno="",year="",serialno="";
                  Title = "Online Thesis Submission";
                  Head = "Student Information";
                  myHeader.printHead(Title,Head,out);
                  String str1="<center>";
                  str1+="<TABLE>";
                  str1+="<TR><TD><FONT SIZE=5> Student Name</FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("sname")[0]+"</FONT></TD></TR>";
                  str1+="<TR><TD><FONT SIZE=5> Student Roll No</FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("roll")[0]+"</FONT></TD></TR>";
                  str1+="<TR><TD><FONT SIZE=5> Thesis Type</FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("Type")[0]+"</FONT></TD></TR>";
                  str1+="<TR><TD><FONT SIZE=5> Title of Thesis</FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("title")[0]+"</FONT></TD></TR>";
                  str1+="<TR><TD><FONT SIZE=5> Name of Guide</FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("fname")[0]+"</FONT></TD></TR>";
                  str1+="<TR><TD><FONT SIZE=5> Department</FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("dname")[0]+"</FONT></TD></TR>";
                  str1+="<TR><TD><FONT SIZE=5> Email</FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("email")[0]+"</FONT></TD></TR>";
                  str1+="<TR><TD><FONT SIZE=5> Address</FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("address")[0]+"</FONT></TD></TR>";
                  str1+="</TABLE>";
                  String roll=req.getParameterValues("roll")[0];
                  String type=req.getParameterValues("Type")[0];
                  String Stg="select dno from auth_table where login='"+roll+"'";
                  ResultSet Dno=Stmt.executeQuery(Stg); 
                  if(Dno.next()){
                        dno=Dno.getString(1);
                  }	
                  Stg="select serialno from student_thesis where sroll='"+roll+"'and type='"+type+"'";
                  ResultSet Result=Stmt.executeQuery(Stg);
                  if(Result.next()){
                        serialno=Result.getString(1);
                  }
                  Stg="select year from thesis where serialno='"+serialno+"'";
                  ResultSet Year=Stmt.executeQuery(Stg); 
                  if(Year.next()){
                        year=Year.getString(1);
                  }	

                  String file=thesisDir+"/"+dno+"/"+year+"/"+type+"/"+roll+".html";
                  str1+="<br><a href=\""+file+"\"> Thesis</a><br>";
                  str1+="<u>Abstract of the thesis</u><br>"+req.getParameterValues("Abstract")[0]+"<br>";
                  String status=req.getParameterValues("status")[0];
                  if(status.compareTo("y") != 0){
                        str1+="The thesis has not been approved.";
                  }
                  else{
                        str1+="The thesis has been approved.";
                  }
                  str1+="</font></center>";
                  out.println(str1);
                  myHeader.printFooter(out);
                  myHeader.printMain(out);
                  out.println("</BODY></HTML>");
            } catch(SQLException e){}
      }

                  /** Methid to  Open the file with name Filename and just
                    * print the contents of it!! 
                    * @param Filename Filename as string
                    * @param out PrintWriter instance
                    * @return Nothing
                    */
      public void printRespectivePage(String Filename,PrintWriter out)
            throws FileNotFoundException,IOException{
                 
                  try{
                        FileInputStream file = new FileInputStream(Config.Dir+Filename);
                        InputStreamReader reader = new InputStreamReader(file);
                        BufferedReader input = new BufferedReader(reader);
                        String nextLine;
                        while((nextLine=input.readLine())!=null){
                              out.println(nextLine);
                        }
                        input.close();
                        reader.close();
                        file.close();
                  } catch(FileNotFoundException e){}
            }
}
