import java.io.*;
import java.net.*; 
import java.lang.*;
import java.lang.Math;
import java.util.*;
import java.util.Date;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import Config;
import Header;
import Errors;

         /** Class to handle the root session. All things done by
           * root such (insertion,deletion,updation) of tuples,
           * changing password of any user, plus many more ( look
           * at methods below for an exhaustive list ) are being 
           * implemented in this servlet session
           */

public class RootSession extends Session{

      Header myHeader = new Header();
      String Title="",Head="";

            /** Method to Read from the corresponding form and print back
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @param Req HttpServletRequest instance
              * @param Cook Cookie as a String 
              * @return  Nothing
              */  
      public void printPage(Connection Conn,PrintWriter out,HttpServletRequest Req,String cook){
            
            try{
                  Integer form_no = new Integer(Req.getParameterValues("form_no")[0]);
                  switch(form_no.intValue()){
                        case 0:
                              this.printRootPage(out);
                              break;
                        case 1:
                              this.printMembersPage(Conn,out," ");
                              break;
                        case 2:
                              this.printTypesPage(Conn,out," ");
                              break;
                        case 3:
                              this.printRelationPage(Conn,out," ");
                              break;
                        case 102:
                              this.printRootPage(out);
                              break;
                  }
            } catch(NumberFormatException e){}
      }
            /** Method to print  the root page
              * @param out PrintWriter instance
              * @return  Nothing
              */
      public void printRootPage(PrintWriter out){

            String logg;
            try{
                  FileWriter rootlogFile = new FileWriter(Config.RootLog, true);
                  PrintWriter toFile = new PrintWriter(rootlogFile);
                  PresentTime GetTime = new PresentTime();

                  toFile.println(loginId+" "+GetTime.gettime());
                  rootlogFile.close();
            } catch (IOException e){
                  e.printStackTrace();
            }
            Title = "Online Thesis Submission";
            Head = "Root Page";
            myHeader.printHead(Title,Head,out);
            String s="";
            s="<center><table border=2 cellpadding=2 cellspacing=2 bgcolor='"+Config.tablecolor+"'>";
            out.println(s);

            s="<tr><td>";
            out.println(s);
            myHeader.printMain(out);
            s="<center><FONT size=5><input type=submit value=Members></FONT></center>";
            s+="<input type=hidden name=form_no value=1></form>";
            out.println(s);
            s="</td><td>Information about the people registered</td>";
            s+="</tr>";
            out.println(s);

            s="<tr><td>";
            out.println(s);
            myHeader.printMain(out);
            s="<FONT size=5><center><input type=submit value=\"Thesis Types\"></center></FONT>";
            s+="<input type=hidden name=form_no value=2></form>";
            out.println(s);
            s="</td><td>A look of the various types of thesis available</td>";
            s+="</tr>";
            out.println(s);

            s="<tr><td>";
            out.println(s);
            myHeader.printMain(out);
            s="<FONT size=5><center><input type=submit value=Relations></center></FONT>";
            s+="<input type=hidden name=form_no value=3></form>";
            out.println(s);
            s="</td><td>Details about the students and guides</td>";
            s+="</tr>";
            out.println(s);

            s="<tr><td>";
            out.println(s);
            myHeader.printMain(out);
            s="<FONT size=5><center><input type=submit value=\"Change Password\"></center></FONT>";
            s+="<input type=hidden name=form_no value=101></form>";
            out.println(s);
            s="</td><td>Enables changing a person's password</td>";
            s+="</tr>";
            out.println(s);

            s="<tr><td>";
            out.println(s);
            myHeader.printMain(out);
            s="<FONT size=5><center><input type=submit value=\"Group Mail\"></center></FONT>";
            s+="<input type=hidden name=form_no value=105></form>";
            out.println(s);
            s="</td><td>Send mails to a particular group</td>";
            s+="</tr>";
            out.println(s);

            s="</table></center>";
            out.println(s);
            try{
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"rootFoot.html",out);
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"logout.html",out);
                  myHeader.printFooter(out);
            }catch(FileNotFoundException e){}
            catch(IOException e){}
            out.println("</body></html>");
      }

            /** Method to print the members page
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @param status Status (whether insertion/deletion failed/succeeded ) as a string
              * @return  Nothing
              */
      public void printMembersPage(Connection Conn,PrintWriter out,String status){
            try{
                  String s="";
                  Title = "Online Thesis Submission";
                  Head = "Insert or Delete a Member";
                  myHeader.printHead(Title,Head,out);

                  s="<center><FONT size=5>"+status+"</FONT></center>";
                  out.println(s);

                  myHeader.printMain(out);
                  this.printRespectivePage(Config.Dir+"insert_members1.html",out);
                  Statement Stmt=Conn.createStatement();
                  ResultSet depts=Stmt.executeQuery("select * from department");
                  s="<TD><font SIZE=5><SELECT NAME=dept>";
                  while(depts.next()){
                        s+="<OPTION VALUE="+depts.getString(1)+">"+depts.getString(2);
                  }
                  s+="</SELECT></FONT></TD>";
                  out.println(s);
                  this.printRespectivePage(Config.Dir+"insert_members2.html",out);
                  myHeader.printMain(out);		
                  s="<HR> <CENTER><FONT SIZE=5><INPUT TYPE=SUBMIT ";	
                  s+="VALUE=\"Insert from a File\"><INPUT TYPE=HIDDEN NAME=form_no value=10>";
                  s+="</FONT></CENTER></FORM>";	
                  out.println(s);	
                  s="<HR><CENTER><FONT SIZE=5>Current Members</FONT>";
                  s+="<TABLE><TR><TD>";
                  out.println(s);
                  myHeader.printMain(out);
                  s="<FONT SIZE=3><INPUT TYPE=submit value=\"Student List\"></FONT>";
                  s+="<INPUT TYPE=HIDDEN NAME=form_no VALUE=12></FORM></TD><TD>";
                  out.println(s);
                  myHeader.printMain(out);
                  s="<FONT SIZE=3><INPUT TYPE=SUBMIT VALUE=\"Faculty List\"></FONT>";
                  s+="<INPUT TYPE=HIDDEN NAME=form_no VALUE=13></FORM></TD><TD>";
                  out.println(s);
                  myHeader.printMain(out);
                  s="<FONT SIZE=3><INPUT TYPE=SUBMIT VALUE=\"Root List\"></FONT><INPUT TYPE=HIDDEN NAME=form_no VALUE=14>";
                  s+="</FORM></TD></TR></TABLE></CENTER></BODY></HTML>";
                  out.println(s);
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"rootFoot.html",out);
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"logout.html",out);
                  myHeader.printFooter(out);
                  out.println("</BODY></HTML>");
            } catch(SQLException e){}
            catch(FileNotFoundException e){} 
            catch(IOException e){}
      }	

            /** Method to print the relation of members page
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @param status Status (whether insertion/deletion failed/succeeded ) as a string
              * @return  Nothing
              */
      public void printRelationPage(Connection Conn,PrintWriter out,String status){
            try{
                  String s="";
                  Title = "Online Thesis Submission";
                  Head = "Insert Or Delete a Relation";
                  myHeader.printHead(Title,Head,out);

                  s="<center><FONT size=5>"+status+"</FONT></center>";
                  out.println(s);

                  myHeader.printMain(out);
                  this.printRespectivePage(Config.Dir+"insert_relation1.html",out);
                  Statement Stmt=Conn.createStatement();
                  ResultSet types=Stmt.executeQuery("select * from types");
                  s="<FONT size=5><select name=type>";
                  while(types.next()){
                        s+="<option value="+types.getString(1)+">"+types.getString(1).toUpperCase();
                  }
                  s+="</select></FONT>";
                  out.println(s);
                  this.printRespectivePage(Config.Dir+"insert_relation2.html",out);
                  myHeader.printMain(out);		
                  s="<HR> <CENTER><FONT SIZE=5><INPUT TYPE=SUBMIT ";	
                  s+="VALUE=\"Insert from a File\"><INPUT TYPE=HIDDEN NAME=form_no value=15>";
                  s+="</FONT></CENTER></FORM>";	
                  out.println(s);	
                  myHeader.printMain(out); 
                  s="<hr> <center><FONT size=5><input type=submit ";
                  s+="value=\"Current Relations\">";
                  s+="<input type=hidden name=form_no value=9>";
                  s+="</FONT></center></form>";
                  out.println(s);
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"rootFoot.html",out);
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"logout.html",out);
                  myHeader.printFooter(out);
                  out.println("</BODY></HTML>");
            } catch(SQLException e){} 
            catch(FileNotFoundException e){}
            catch(IOException e){}
      }	
            /** Method to print the `type of submission` page
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @param status Status (whether insertion/deletion failed/succeeded ) as a string
              * @return  Nothing
              */
      public void printTypesPage(Connection Conn,PrintWriter out,String status){
            try{
                  String s="";
                  Title = "Online Thesis Submission";
                  Head = "Insert Or Delete a Type";
                  myHeader.printHead(Title,Head,out);

                  s="<center><FONT size=5>"+status+"</FONT></center>";
                  out.println(s);

                  myHeader.printMain(out);
                  this.printRespectivePage(Config.Dir+"insert_type.html",out);

                  myHeader.printMain(out); 
                  s="<HR> <CENTER><FONT SIZE=5><INPUT TYPE=SUBMIT ";
                  s+="VALUE=\"Current Types\">";
                  s+="<INPUT TYPE=HIDDEN NAME=form_no VALUE=8>";
                  s+="</FONT></CENTER></FORM>";
                  out.println(s);

                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"rootFoot.html",out);
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"logout.html",out);
                  myHeader.printFooter(out);
                  out.println("</body></html>");
            }  catch(FileNotFoundException e){}
            catch(IOException e){}
      }

            /** Method for multiple insertion from a file
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @param num Number of insertions to be done
              * @return  Nothing
              */
      public void printMultiplePage(Connection Conn, PrintWriter out,int num){
            try{
                  Title = "Online Thesis Submission";
                  Head = "Insert from a file";
                  myHeader.printHead(Title,Head,out);
                  String Message="";
                  Message = "<p><CENTER>This facility allows you to upload information directly from a file.<BR> Kindly specify the URL of the file to be uploaded.</CENTER>";
                  out.println(Message);
                  myHeader.printMain(out);
                  this.printRespectivePage(Config.Dir+"insert_mult.html",out);
                  out.println("<INPUT TYPE=HIDDEN NAME=form_no VALUE="+num+">");
                  if (num == 11){ //inserting members
                        String choice = "";
                        choice = "<CENTER><TABLE>";
                        choice += "<TR><TD><INPUT TYPE=RADIO NAME=members VALUE=students CHECKED><FONT SIZE=4> Insert Students</FONT></TD></TR>";
                        choice += "<TR><TD><INPUT TYPE=RADIO NAME=members VALUE=faculty><FONT SIZE=4> Insert Faculty</FONT></TD></TR>";
                        choice += "</TABLE></CENTER>";
                        out.println(choice);
                  }
                  this.printRespectivePage(Config.Dir+"insert_mult2.html",out);
                  out.println("</FONT></CENTER></FORM>");
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"rootFoot.html",out);
                  myHeader.printMain(out);
                  myHeader.printPage(Config.Dir+"logout.html",out);
                  myHeader.printFooter(out);
                  out.println("</BODY></HTML>");
            }catch(FileNotFoundException e){}
            catch(IOException e){}
      }

            /** Method for processing the data
              * @param Req HttpServletRequest instance
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @return  Nothing
              */

      public void processData(HttpServletRequest Req,Connection Conn,PrintWriter out){
            try{
                  Integer form_no = new Integer(Req.getParameterValues("form_no")[0]);
                  switch(form_no.intValue()){
                        case 4:
                              memberHandler(Req,Conn,out);
                              break;
                        case 5:
                              typeHandler(Req,Conn,out);
                              //Title = "Online Thesis Submission";
                              //Head = "Insert or Delete a Type";
                              // all this              //myHeader.printHead(Title,Head,out);
                              //commenting by sunny	//myHeader.printMain(out);
                              //this.printRespectivePage(Config.Dir+"insert_type.html",out);
                              break;
                        case 6:
                              relationHandler(Req,Conn,out);
                              break;
                              //		case 7:
                              //			printMembers(out,Conn);
                              //			break;
                              // commented by ajain and vkb on Thu Oct 21 21:40:08 IST 1999
                        case 8:
                              printTypes(out,Conn);
                              break;
                        case 9:
                              printRelations(out,Conn);
                              break;
                        case 10:				
                              printMultiplePage(Conn,out,11);	
                              break;				
                        case 11:
                              multipleHandler(Req,Conn,"members");
                              this.printMultiplePage(Conn,out,11);
                              break;
                        case 12:
                              printMembers_Students(out,Conn);
                              break;
                        case 13:
                              printMembers_Faculty(out,Conn);
                              break;
                        case 14:
                              printMembers_Root(out,Conn);
                              break;
                        case 15:
                              printMultiplePage(Conn,out,16);	
                              break;
                        case 16:
                              multipleHandler(Req,Conn,"student_faculty");
                              this.printMultiplePage(Conn,out,16);
                              break;
                  }
            } catch(NumberFormatException e){}
            //catch(FileNotFoundException e){}  
            //catch(IOException e){}  
      }

            /** Method for manipulating the student-faculty relations
              * @param Req HttpServletRequest instance
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @return  Nothing
              */

      public void relationHandler(HttpServletRequest req,Connection Conn,PrintWriter out){
            String status="";
            try{ 
                  Statement Stmt=Conn.createStatement();
                  String Ins="";
                  if(req.getParameterValues("insert_delete")[0].compareTo("1")==0){
                        Ins="select * from student_faculty where sroll='"+req.getParameterValues("slogin")[0]+"' and type='"+ req.getParameterValues("type")[0]+"'";
                        ResultSet Auth_result=Stmt.executeQuery(Ins);
                        if(Auth_result.next()){
                              status="Insertion failed. Relation exists.";
                        }
                        else {
                              Ins="insert into student_faculty values('";
                              Ins+=this.checkQuote(req.getParameterValues("slogin")[0])+"','";
                              Ins+=this.checkQuote(req.getParameterValues("flogin")[0])+"','";
                              Ins+=this.checkQuote(req.getParameterValues("type")[0])+"','";
                              Ins+=this.checkQuote(req.getParameterValues("clogin")[0]);
                              Ins+="')";
                              Stmt.executeUpdate(Ins);
                              /* write into logs */
                              try {
                                    FileWriter rootlogFile = new FileWriter(Config.RootLog,true);
                                    PrintWriter toFile = new PrintWriter(rootlogFile);
                                    PresentTime GetTime = new  PresentTime();
                                    toFile.println(" Root insertion into relational handler");
                                    toFile.println(Ins + " @ " + GetTime.gettime());
                                    toFile.println(" ");
                                    rootlogFile.close();
                              }catch(IOException e){
                              }

                              status="Insertion successful";
                        }
                  }
                  else if(req.getParameterValues("insert_delete")[0].compareTo("2")==0){
                        Ins="select * from student_faculty where sroll='"+req.getParameterValues("slogin")[0]+"' and type='"+ req.getParameterValues("type")[0]+"'";
                        Ins+=" and loginid='"+req.getParameterValues("flogin")[0]+"'";
                        ResultSet Auth_result=Stmt.executeQuery(Ins);

                        if(Auth_result.next()){
                              status="Deletion Successful.";
                              Ins="delete from student_faculty where sroll='";
                              Ins+=checkQuote(req.getParameterValues("slogin")[0])+"'";
                              Ins+="and loginid='";
                              Ins+=checkQuote(req.getParameterValues("flogin")[0])+"'";
                              Ins+="and type='";
                              Ins+=checkQuote(req.getParameterValues("type")[0])+"'";
                              Stmt.executeUpdate(Ins);
                        }
                        else {
                              status="Deletion failed. Relation does not exist.";
                        }
                  }
                  this.printRelationPage(Conn,out,status);
            }catch(SQLException e){
                  status="There was an error please check if the data is correct.";
                  this.printRelationPage(Conn,out,status);
            } 
      }	

            /** Method to make life easier for the root. Here the root
              * can insert multiple members from a file itself without
              * having to physically enter the data for each member
              * individually and posting the form again and again
              * @param Req HttpServletRequest instance
              * @param Conn Connection instance
              * @param table The name of the table where insertion has to be done
              * @return  Nothing
              */
      public void multipleHandler(HttpServletRequest req, Connection con,String table){
            try{
                  Statement Stmt = con.createStatement();
                  String att="";
                  String nextLine="";
                  String Ins="";

                  String Url = "";
                  Url=req.getParameterValues("fname")[0];
                  int index=Url.indexOf("/",0);	
                  String hostname = Url.substring(0,index);
                  String filename = Url.substring(index);
                  URL myURL = new URL("http",hostname,-1,filename);
                  InputStream myStream = myURL.openStream();

                  InputStreamReader reader = new InputStreamReader(myStream);
                  BufferedReader input = new BufferedReader(reader);

                  /* if inserting members, extract the name of the table, students or faculty from user's selection*/
                  if (table.equals("members")){
                        table=req.getParameterValues("members")[0];
                  }
                  while((nextLine=input.readLine())!=null){
                        StringTokenizer lineToken = new StringTokenizer(nextLine,":"); 
                        Ins = "insert into "+ table +" values('";
                        Ins += lineToken.nextToken()+"','";
                        Ins += lineToken.nextToken()+"','";
                        Ins += lineToken.nextToken()+"','";
                        Ins += lineToken.nextToken()+"'";
                        if (table.equals("students")){
                              Ins += ",'"+lineToken.nextToken()+"'";
                        }
                        Ins += ")";
                        Stmt.execute(Ins);
                  }
            }catch(SQLException e){}
            catch(FileNotFoundException e){}
            catch(IOException e){}
      }

            /** Method for inserting members into auth_table
              * @param Req HttpServletRequest instance
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @return  Nothing
              */

      public void memberHandler(HttpServletRequest req,Connection Conn,PrintWriter out){
            try{ 
                  Statement Stmt=Conn.createStatement();
                  String Ins="";
                  String status="";
                  if(req.getParameterValues("insert_delete")[0].compareTo("1")==0){
                        Ins="select * from auth_table where login='"+checkQuote(req.getParameterValues("login")[0])+"'";
                        ResultSet Auth_result=Stmt.executeQuery(Ins);
                        if(Auth_result.next()){
                              status="Insertion failed. User exists.";
                        }
                        else {
                              Ins="insert into auth_table values('";
                              Ins+=this.checkQuote(req.getParameterValues("login")[0])+"','";
                              Ins+=this.checkQuote(req.getParameterValues("password")[0])+"','";
                              Ins+=this.checkQuote(req.getParameterValues("dept")[0])+"','";
                              Ins+=this.checkQuote(req.getParameterValues("member")[0]);
                              Ins+="')";
                              Stmt.executeUpdate(Ins);

                              try {
                                    FileWriter rootlogFile=new FileWriter(Config.RootLog,true);
                                    PrintWriter toFile= new PrintWriter(rootlogFile);
                                    PresentTime GetTime=new  PresentTime();
                                    toFile.println(Ins + " @ " + GetTime.gettime());
                                    toFile.println(" ");
                                    rootlogFile.close();
                              } catch(IOException e){
                              }



                              status="Insertion successful";
                        }
                  }
                  else if(req.getParameterValues("insert_delete")[0].compareTo("2")==0){
                        Ins="select * from auth_table where login='"+checkQuote(req.getParameterValues("login")[0])+"'";
                        ResultSet Auth_result=Stmt.executeQuery(Ins);
                        if(Auth_result.next()){
                              status="delete successful";
                              Ins="delete from auth_table where login='"+checkQuote(req.getParameterValues("login")[0])+"'";
                              Stmt.executeUpdate(Ins);

                              try {
                                    FileWriter rootlogFile=new FileWriter(Config.RootLog,true);
                                    PrintWriter toFile= new PrintWriter(rootlogFile);
                                    PresentTime GetTime=new  PresentTime();
                                    toFile.println(Ins + " @ "+GetTime.gettime());
                                    toFile.println(" ");
                                    rootlogFile.close();
                              } catch(IOException e){
                              }

                        }
                        else {
                              status="deletion failed";
                        }
                  }
                  this.printMembersPage(Conn,out,status);
            }catch(SQLException e){Errors.printError("SQLException",e.toString(),out);}
      }	
      /*    public void printMembers(PrintWriter out,Connection Conn){
            try{    
            Statement Stmt=Conn.createStatement();
            String s="";
            Title = "Online Thesis Submission";
            Head = "Members";
            myHeader.printHead(Title,Head,out);
            ResultSet types=Stmt.executeQuery("select * from auth_table where type='student'");
            s+="<br><br><FONT size=5><center><u>STUDENTS</u><br>";
            while(types.next()){
            s+="<FONT size=4><center>"+types.getString(1)+"  ";
            s+=types.getString(3)+"  ";
            s+=types.getString(4);
            s+="</center></FONT><br>";
            }

            types=Stmt.executeQuery("select * from auth_table where type='faculty'");
            s+="<br><br><FONT size=5><center><u>FACULTY</u><br>";
            while(types.next()){
            s+="<FONT size=4><center>"+types.getString(1)+"  ";
            s+=types.getString(3)+"  ";
            s+=types.getString(4);
            s+="</center></FONT><br>";
            }

            types=Stmt.executeQuery("select * from auth_table where type='root'");
            s+="<br><br><FONT size=5><center><u>ROOT</u><br>";
            while(types.next()){
            s+="<FONT size=4><center>"+types.getString(1)+"  ";
            s+=types.getString(3)+"  ";
            s+=types.getString(4);
            s+="</center></FONT><br>";
}

s+="</body></html>";
out.println(s);
} catch(SQLException e){} 
}	*/ 
// commented by ajain and vkb on Thu Oct 21 21:43:22 IST 1999
            
             /** Method for printing the student members
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @return  Nothing
              */
public void printMembers_Students(PrintWriter out,Connection Conn){
      try{
            Statement Stmt=Conn.createStatement();
            String s="";
            Title = "Online Thesis Submission";
            Head  = "Members";
            myHeader.printHead(Title,Head,out);
            ResultSet types=Stmt.executeQuery("select * from auth_table where type='student'");
            s+="<BR><BR>";
            s+="<center><table border=2 cellspacing=5 cellpadding=5 bgcolor='"+Config.tablecolor+"'>";
            s+="<caption><Strong><FONT SIZE=5>STUDENTS</FONT></Strong></caption>";
            s+="<thead><bold><tr><td><Center>NAME</Center></td><td><Center>DEPT. CODE</Center></td></tr></bold></thead>";
            s+="<Font size=4>";
            while(types.next()){
                  s+="<tr><td><CENTER>"+types.getString(1)+"</center></td>";
                  s+="<td><center>"+types.getString(3)+"</center></td>";
                  //s+=types.getString(4);
                  s+="</tr>";
            }
            s+="</table></center></font>";
            out.println(s);
            myHeader.printMain(out);
            myHeader.printPage(Config.Dir+"rootFoot.html",out);
            myHeader.printMain(out);
            myHeader.printPage(Config.Dir+"logout.html",out);
            myHeader.printFooter(out);
            out.println("</BODY></HTML>");
      } catch(SQLException e){} 
      catch(FileNotFoundException e){}
      catch(IOException e){}
}	
             /** Method for printing the faculty members
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @return  Nothing
              */
public void printMembers_Faculty(PrintWriter out,Connection Conn){
      try{    
            Statement Stmt=Conn.createStatement();
            String s="";
            Title = "Online Thesis Submission";
            Head = "Members";
            myHeader.printHead(Title,Head,out);

            ResultSet types=Stmt.executeQuery("select * from auth_table where type='faculty'");
            s+="<br><br>";
            s+="<Font size=4>";
            s+="<center><table border=2 cellspacing=5 cellpadding=5 bgcolor='"+Config.tablecolor+"'>";
            s+="<caption><FONT SIZE=5><Strong>FACULTY</Strong></FONT></caption>";
            s+="<thead><bold><tr><td><Center>NAME</Center></td><td><Center>DEPT. CODE</Center></td></tr></bold></thead>";
            while(types.next()){
                  s+="<tr>";
                  s+="<td><center>"+types.getString(1)+"</center></td>";
                  s+="<td><center>"+types.getString(3)+"</center></td>";
                  //s+=types.getString(4);
                  s+="</tr>";
            }
            s+="</table></center></FONT><br>";
            out.println(s);
            myHeader.printMain(out);
            myHeader.printPage(Config.Dir+"rootFoot.html",out);
            myHeader.printMain(out);
            myHeader.printPage(Config.Dir+"logout.html",out);
            myHeader.printFooter(out);
            out.println("</body></html>");
      } catch(SQLException e){} 
      catch(FileNotFoundException e){}
      catch(IOException e){}
}	
             /** Method for printing the members who have root perms
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @return  Nothing
              */
public void printMembers_Root(PrintWriter out,Connection Conn){
      try{    
            Statement Stmt=Conn.createStatement();
            String s="";
            Title = "Online Thesis Submission";
            Head = "Members";
            myHeader.printHead(Title,Head,out);

            ResultSet types=Stmt.executeQuery("select * from auth_table where type='root'");
            s+="<br><br>";
            s+="<Font size=4>";
            s+="<center><table border=2 cellspacing=5 cellpadding=5 bgcolor='"+Config.tablecolor+"'>";
            s+="<caption><FONT SIZE=5><Strong>ROOT</Strong></FONT></caption>";
            s+="<thead><bold><tr><td><Center>NAME</Center></td></tr></bold></thead>";
            while(types.next()){
                  s+="<tr><td><center>"+types.getString(1)+"</center></td></tr>";
                  //s+=types.getString(3)+"  ";
                  //s+=types.getString(4);
            }
            s+="</table></center></FONT><br>";
            out.println(s);
            myHeader.printMain(out);
            myHeader.printPage(Config.Dir+"rootFoot.html",out);
            myHeader.printMain(out);
            myHeader.printPage(Config.Dir+"logout.html",out);
            myHeader.printFooter(out);
            out.println("</body></html>");
      } catch(SQLException e){} 
      catch(FileNotFoundException e){}
      catch(IOException e){}
}	

             /** Method for printing the student-guide relations
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @return  Nothing
              */
public void printRelations(PrintWriter out,Connection Conn){
      try{    
            Statement Stmt=Conn.createStatement();
            String s="";
            Title = "Online Thesis Submission";
            Head = "Relations";
            myHeader.printHead(Title,Head,out);
            ResultSet types=Stmt.executeQuery("select * from student_faculty");
            s+="<center><table border=2 cellspacing=5 cellpadding=5 bgcolor='"+Config.tablecolor+"'>";
            s+="<font size=5>";
            s+="<thead><tr><td>Student</td><td>Guide</td><td>Co-guide</td><td>Thesis Type</td></tr></thead>";
            s+="</font>";
            s+="<font size=4>";
            while(types.next()){
                  s+="<tr>";
                  s+="<td><center>"+types.getString(1)+"</center></td>";
                  s+="<td><center>"+types.getString(2)+"</center></td>";
                  s+="<td><center>"+types.getString(4)+"</center></td>";
                  s+="<td><center>"+types.getString(3)+"</center></td>";
                  s+="</tr>";
            }
            s+="</font></table></center>";
            out.println(s);
            myHeader.printMain(out);
            myHeader.printPage(Config.Dir+"rootFoot.html",out);
            myHeader.printMain(out);
            myHeader.printPage(Config.Dir+"logout.html",out);
            myHeader.printFooter(out);
            out.println("</body></html>");
      } catch(SQLException e){} 
      catch(FileNotFoundException e){}
      catch(IOException e){}
}	

            /** Method for printing the distinct types of submissions
              * In our case the distinct types will be Seminar, Btp, Thesis 
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @return  Nothing
              */
public void printTypesMail(PrintWriter out,Connection Conn){
      String s="";
      try{
            Statement Stmt=Conn.createStatement();
            String Query="select distinct type from student_faculty";
            ResultSet types=Stmt.executeQuery(Query);
            s+="<TR><TD><FONT SIZE=5>Type of Thesis</FONT></TD><TD><FONT SIZE=5><SELECT NAME=type>";
            while(types.next()){
                  s+="<OPTION VALUE="+types.getString(1)+">"+types.getString(1).toUpperCase();
            }
            s+="<OPTION VALUE='All'>ALL";
            s+="</SELECT></FONT></TD></TR>";
            out.println(s);
      }catch(SQLException e){}
}

            /** Method for inserting/deleting types
              * @param req HttpServletRequest instance
              * @param Conn Connection instance
              * @param out PrintWriter instance
              * @return  Nothing
              */
public void typeHandler(HttpServletRequest req,Connection Conn,PrintWriter out){
      String status="";
      String Auth_query="";
      try{ 
            Statement Stmt=Conn.createStatement();
            String Ins="";
            if(req.getParameterValues("insert_delete")[0].compareTo("1")==0){
                  Ins="insert into types values('"+this.checkQuote(req.getParameterValues("type")[0])+"')";

                  Auth_query= "select * from types where type='"+checkQuote(req.getParameterValues("type")[0])+"'";
                  Statement st = Conn.createStatement();
                  ResultSet Auth_result=st.executeQuery(Auth_query);
                  if(Auth_result.next()){
                        status="Insertion failed--type already exists";
                  }
                  else {
                        status="Insertion successful.";
                        Stmt.executeUpdate(Ins);
                        try {
                              FileWriter rootlogFile=new FileWriter(Config.RootLog,true);
                              PrintWriter toFile= new PrintWriter(rootlogFile);
                              PresentTime GetTime=new  PresentTime();
                              toFile.println(Ins + " @ "+ GetTime.gettime());
                              toFile.println(" ");
                              rootlogFile.close();
                        } catch(IOException e){
                        }

                  }
            }

            else if(req.getParameterValues("insert_delete")[0].compareTo("2")==0){
                  Ins="delete from types where type='"+checkQuote(req.getParameterValues("type")[0])+"'";

                  Auth_query= "select * from types where type='"+checkQuote(req.getParameterValues("type")[0])+"'";
                  Statement st = Conn.createStatement();
                  ResultSet Auth_result=st.executeQuery(Auth_query);
                  if(Auth_result.next()){
                        status="Deletion Successful";
                        Stmt.executeUpdate(Ins);

                        try {
                              FileWriter rootlogFile=new FileWriter(Config.RootLog,true);
                              PrintWriter toFile= new PrintWriter(rootlogFile);
                              PresentTime GetTime=new  PresentTime();
                              toFile.println(Ins + " @ "+GetTime.gettime());
                              toFile.println(" ");
                              rootlogFile.close();
                        } catch(IOException e){
                        }

                  }
                  else {
                        status="Deletion Failed--type does not exist";
                  }
            }
            this.printTypesPage(Conn,out,status);
      }catch(SQLException e){Errors.printError("SQLException",e.toString(),out);}
}	

            /** Method to Open the file with name Filename and just print
              * the contents of it 
              * @param Filename Name of file as a String
              * @param out PrintWriter instance
              * @return  Nothing
              */
public void printRespectivePage(String Filename,PrintWriter out)
      throws FileNotFoundException,IOException{

            try{
                  FileInputStream file = new FileInputStream(Filename);
                  InputStreamReader reader = new InputStreamReader(file);
                  BufferedReader input = new BufferedReader(reader);
                  String nextLine;
                  while((nextLine=input.readLine())!=null){
                        out.println(nextLine);
                  }
                  input.close();
                  reader.close();
                  file.close();
            } catch(FileNotFoundException e){}
      }
      /*
         public void printTypes(PrintWriter out,Connection Conn){
         String s="";
         try{
         Statement Stmt=Conn.createStatement();
         String Query="select type from student_faculty";
         ResultSet types=Stmt.executeQuery(Query);
         s+="<TR><TD><FONT SIZE=5>Type of Thesis</FONT></TD><TD><FONT SIZE=5><SELECT NAME=type>";
         while(types.next()){
         s+="<OPTION VALUe="+types.getString(1)+">"+types.getString(1).toUpperCase();
         }
         s+="</SELECT></FONT></TD></TR>";
         out.println(s);
         }catch(SQLException e){}
         }
       */

            /** Method to print the types
              * @param out PrintWriter instance
              * @param Conn Connection instance
              * @return  Nothing
              */
      public void printTypes(PrintWriter out,Connection Conn){
            Title = "Online Thesis Submission";
            Head = "Types";
            myHeader.printHead(Title,Head,out);
            try{    
                  Statement Stmt=Conn.createStatement();
                  String s="";
                  ResultSet types=Stmt.executeQuery("select * from types");
                  while(types.next()){
                        s+="<font size=5><center>"+types.getString(1);
                        s+="</center></font><br>";
                  }
                  out.println(s);
                  try{
                        myHeader.printMain(out);
                        myHeader.printPage(Config.Dir+"rootFoot.html",out);
                        myHeader.printMain(out);
                        myHeader.printPage(Config.Dir+"logout.html",out);
                        myHeader.printFooter(out);
                  }catch(FileNotFoundException e){}
                  catch(IOException e){}

                  s="</body></html>";
                  out.println(s);
            } catch(SQLException e){} 
      }	

            /** Method to check for single-quotes ( ' )
              * @param initString String fed, which might have quotes in it
              * @return A string not having any single-quotes in it.
              */
      String checkQuote(String initString){
            int beginindex=0,endindex=0;
            String returnString="";
            for(;;){
                  endindex=initString.indexOf("'",beginindex);
                  if(endindex==-1){
                        returnString+=initString.substring(beginindex);
                        break;
                  }
                  else{
                        returnString+=initString.substring(beginindex,endindex)+"''";
                        beginindex=endindex+1;
                  }
            }
            return(returnString);
      }	
      }

