import java.io.*;
import java.util.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import Config;

       /** Class invoked everytime one `Make`s the whole package
         * Does preliminary things such as setting up the Starting page.
         * It can also be modified to invoke creation of tables. The
         * method has been written but not invoked because it is not 
         * feasible to drop tables everytime one compiles and starts 
         * Start.java 
         * Assumption : Tables will be created only once in ETD's lifetime.
         * Institute database will be so large that it is not advisable to 
         * drop tables without backup.
         *
         */
public class Start{

    private static Connection Conn;
    public static void main(String argv[]){
	createStartPage(); // Create the starting page.
      
   //   createTables(); Has been commented out for the aforementioned 
   //  reasons   
    }
         /** Method to create the tables
           * @param nothing
           * @return nothing
           */
    public static void createTables(){
          try{
                DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
                Conn=DriverManager.getConnection("jdbc:oracle:thin:@everest:1521:GEN",Config.dblogin,Config.dbpassword);		
                Statement Stmt = Conn.createStatement();
                FileInputStream file = new FileInputStream(Config.sqlDir+"tables.sql");
                InputStreamReader reader = new InputStreamReader(file);
                BufferedReader input = new BufferedReader(reader);
                String nextLine;
                while((nextLine=input.readLine())!=null){
                      Stmt.executeUpdate(nextLine);
                }
          }catch(SQLException e){System.out.println("Sorry JDBC not connecting");}
          catch(FileNotFoundException e){}
          catch(IOException e){}
    }

         /** Method to create the starting page
           * @param nothing
           * @return nothing
           */
    public static void createStartPage(){
	try{
	    FileOutputStream fout = new FileOutputStream(Config.pubdir+"/Start.html");
          DataOutputStream dout = new DataOutputStream(fout);
	    String Title="Online Thesis Submission";
	    String Head="";
	    printHead(Title,Head,dout);
          dout.writeBytes("<CENTER><FONT SIZE=5><Strong>INDIAN INSTITUTE OF TECHNOLOGY</Strong></FONT>");
          dout.writeBytes("<P>Online Thesis Submission Page");
          dout.writeBytes("<P>Welcome to electronic thesis submission ");
          dout.writeBytes("<center><A href=\"http://www.iitb.ernet.in\"><IMG src=\""+Config.pubpath+"/imgs/iitb.jpeg\" ALT=\" I I T - B o m b a y\" BORDER=0 ALIGN=center></A></CENTER>");
          printFooter(dout);
	    dout.close();
	    fout.close();
	}catch(FileNotFoundException e){}
	 catch(IOException e){}
    }
         /** Method to create the header of starting page
           * @param title Title of the page as String
           * @param head Head of the page as String
           * @param dout DataOutputStream instance
           * @return nothing
           */
    public static void printHead(String title,String head,DataOutputStream dout){
          try{
                String s="<html> <title>"+title+"</title>";
                s+="<body text="+Config.text+" bgcolor="+Config.bgcolor+">";
                s+="<head><center><h1><u>"+head+"</u></h1></center></head>";
                dout.writeBytes(s);	
          } catch(IOException e){}
    }
         /** Method to create the footer of starting page
           * @param dout DataOutputStream instance
           * @return nothing
           */
    public static void printFooter(DataOutputStream dout){
          try{
                String s;
                s="<HR><TABLE><TR><TD><FORM METHOD=POST ACTION=\"http://"+Config.hostname+":";
                s+=Config.port+"/servlet/Main\">";
                s+="<INPUT TYPE=HIDDEN NAME=form_no VALUE=202>";
                s+="<INPUT TYPE=SUBMIT VALUE=Register></FORM></TD>";

                s+="<TD><FORM METHOD=POST ACTION=\"http://"+Config.hostname+":";
                s+=Config.port+"/servlet/Main\">";
                s+="<INPUT TYPE=HIDDEN NAME=form_no VALUE=201>";
                s+="<INPUT TYPE=SUBMIT VALUE=Login></FORM></TD>";

                s+="<TD><FORM METHOD=POST ACTION=\"http://"+Config.hostname+":";
                s+=Config.port+"/servlet/Query\">";
                s+="<INPUT TYPE=HIDDEN NAME=form_no VALUE=0>";
                s+="<INPUT TYPE=SUBMIT VALUE=Search></FORM></TD>";

                s+="<TD><FORM METHOD=POST ACTION=\"http://"+Config.hostname+":";
                s+=Config.port+"/servlet/Stat\">";
                s+="<INPUT TYPE=HIDDEN NAME=form_no VALUE=0>";
                s+="<INPUT TYPE=SUBMIT VALUE=Statistics></FORM></TD>";

                s+="<TD><FORM METHOD=POST ACTION=\"http://"+Config.hostname+":";
                s+=Config.port+"/servlet/Main\">";
                s+="<INPUT TYPE=HIDDEN NAME=form_no VALUE=100>";
                s+="<INPUT TYPE=SUBMIT VALUE='Change Password'></FORM></TD>";
                s+="</TR></TABLE>";
                dout.writeBytes(s);	
          } catch(IOException e){}
    }

         /** Method to print the FORM ACTION tag of the starting page
           * with the action pointing to servlet `Main`
           * @param dout DataOutputStream instance
           * @return nothing
           */
    public static void printMain(DataOutputStream dout){
          try{
                String s;
                s="<form method=post action=\"http://"+Config.hostname+":";
                s+=Config.port+"/servlet/Main\">";
                dout.writeBytes(s);	
          } catch(IOException e){}
    }
         /** Method to print FORM ACTION of the starting page with action
           * pointing to servlet `Query`
           * @param dout DataOutputStream instance
           * @return nothing
           */
    public static void printQuery(DataOutputStream dout){
          try{
                String s;
                s="<form method=post action=\"http://"+Config.hostname+":";
                s+=Config.port+"/servlet/Query\">";
                dout.writeBytes(s);	
          } catch(IOException e){}
    }
         /** Method to print FORM ACTION of the starting page with action
           * pointing to servlet `Dept`
           * @param dout DataOutputStream instance
           * @return nothing
           */
    public static void printDept(DataOutputStream dout){
          try{
                String s;
                s="<form method=post action=\"http://"+Config.hostname+":";
                s+=Config.port+"/servlet/Dept\">";
                dout.writeBytes(s);	
          } catch(IOException e){}
    }
         /** Method to create the starting page
           * @param Filename Name of file as String
           * @param dout DataOutputStream instance
           * @return nothing
           */
    public static void createPage(String Filename,DataOutputStream dout){
          try{
                FileInputStream file = new FileInputStream(Filename);
                InputStreamReader reader = new InputStreamReader(file);
                BufferedReader input = new BufferedReader(reader);
                String nextLine;
                while((nextLine=input.readLine())!=null){
                      dout.writeBytes(nextLine);	
                      dout.writeByte('\n');
                }
                input.close();
                reader.close();
                file.close();
          } catch(IOException e){}
    }	    
         /** Method to copy the Image file to a FileOutputStream
           * @param Filename Name of file as String
           * @param fout FileOutputStream instance
           * @return nothing
           */
    public static void copyImageFile(String Filename,FileOutputStream fout){
          try{
                FileInputStream file = new FileInputStream(Filename);
                int nextByte;
                while((nextByte=file.read())!=-1){
                      fout.write(nextByte);	
                }
                file.close();
          } catch(IOException e){}
    }	    
}

