import java.io.*;
import java.util.*;
import java.sql.*;
import java.lang.*;
import javax.servlet.*;
import javax.servlet.http.*;
import Config;
import Header;

        /** A class to handle the Statistics servlet. 
          * It caters to the general statistical querries.
          */
public class StatServlet extends HttpServlet implements SingleThreadModel{
      Connection Conn;
      Header myheader = new Header();

      /* Init to set up server connections */
      public void init(ServletConfig cfg) throws ServletException{
            try{
                  DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
                  Conn=DriverManager.getConnection("jdbc:oracle:thin:@:1521:GEN",Config.dblogin,Config.dbpassword);		
            }catch(SQLException e){System.out.println("Sorry JDBC not connecting");}
      }
         /** Class to handle the posted form 
           * @param Req HttpServletRequest instance
           * @param Res HttpServletResponse instance
           * @return Nothing
           */
        
      public void doPost(HttpServletRequest Req, HttpServletResponse Res) throws ServletException, IOException {
            try{	    
                  String Title="", Head="";
                  Res.setContentType("text/html");
                  PrintWriter out = Res.getWriter();

                  Integer form_no=new Integer(Req.getParameterValues("form_no")[0]);
                  String sd;
                  ResultSet rsetd;
                  switch(form_no.intValue()){
                        case 0:         //entering the Stat servelet
                              Title = "Online Thesis Submission";
                              Head = "Statistical Search";
                              myheader.printHead(Title,Head,out);
                              String s="";
                              Statement Stmt;
                              out.println("<CENTER><TABLE BORDER=3 BGCOLOR="+Config.tablecolor+">");
                              out.println("<TR><TD>");
                              myheader.printStat(out);
                              myheader.printPage(Config.Dir+"stat2.html",out);
                              myheader.printStat(out);
                              myheader.printPage(Config.Dir+"stat3.html",out);
                              myheader.printStat(out);
                              myheader.printPage(Config.Dir+"stat4.html",out);
                              myheader.printStat(out);
                              myheader.printPage(Config.Dir+"stat5.html",out);
                              out.println("</TABLE></CENTER>");
                              break;
                        case 2:    // Distribution of theses based on guide
                              Title = "Online Thesis Submission";
                              Head = "Statistical Search Results";
                              myheader.printHead(Title,Head,out);
                              out.println("<BR><CENTER><FONT SIZE=3>Distribution of theses on the basis of the guide</FONT></CENTER><BR>");
                              Statement stmt =Conn.createStatement();
                              String sear="select student_faculty.loginid,count(student_faculty.loginid) from student_faculty,student_thesis,thesis where thesis.serialno=student_thesis.serialno and student_thesis.sroll=student_faculty.sroll and student_faculty.type=student_thesis.type group by student_faculty.loginid";
                              ResultSet rset=stmt.executeQuery(sear);
                              out.println("<CENTER><TABLE BORDER=3 CELLPADDING=5 BGCOLOR='"+Config.tablecolor+"'>");
                              out.println("<TR><FONT SIZE=4><TD>");
                              out.println("Guide</TD><TD><CENTER>Number of Theses</CENTER></TD></FONT></TR>");
                              while(rset.next()){
                                    String name=rset.getString(1);
                                    int noTheses=rset.getInt(2);
                                    out.println("<TR><TD align=center>");
                                    myheader.printStat(out);
                                    out.println("<INPUT TYPE=SUBMIT VALUE="+name+" ><INPUT TYPE=HIDDEN NAME=guide VALUE="+name+"><INPUT TYPE=HIDDEN NAME=form_no VALUE=20></FORM></TD><TD><CENTER>"+noTheses+"</CENTER></TD></TR>"); 
                              } 
                              out.println("</TABLE></CENTER>");
                              break;
                        case 3: // Distribution of Thesis based on department
                              Title = "Online Thesis Submission";
                              Head = "Statistical Search Results";
                              myheader.printHead(Title,Head,out);
                              out.println("<BR><CENTER><FONT SIZE=3>Distribution of theses on the basis of department</FONT></CENTER><BR>");
                              Statement stmtd=Conn.createStatement();
                              sd="create view temp as select sroll from student_thesis,thesis where thesis.serialno=student_thesis.serialno";
                              stmtd.executeQuery(sd);
                              sd="select dname,count(dname) from department,students,temp where department.dno=students.dno and students.sroll=temp.sroll group by dname";
                              rsetd=stmtd.executeQuery(sd);
                              out.println("<CENTER><TABLE BORDER=3 CELLPADDING=5 BGCOLOR='"+Config.tablecolor+"'>");
                              out.println("<TR><FONT SIZE=4><TD><CENTER>Department</CENTER></TD><TD><CENTER>Number of Theses</CENTER></TD></FONT></TR>");
                              while(rsetd.next()){
                                    String name=rsetd.getString(1);
                                    int noTheses=rsetd.getInt(2);
                                    out.println("<TR><TD align=center>");
                                    myheader.printStat(out);
                                    out.println("<INPUT TYPE=SUBMIT VALUE="+name+"><INPUT TYPE=HIDDEN NAME=dept VALUE="+name+"><INPUT TYPE=HIDDEN NAME=form_no VALUE=21></FORM></TD><TD><CENTER>"+noTheses+"</CENTER></TD></TR>"); 
                              } 
                              out.println("</TABLE></CENTER>");
                              sd="drop view temp";
                              stmtd.executeQuery(sd);
                              break;
                        case 4:  // Distribution of Thesis based on type
                              Title = "Online Thesis Submission";
                              Head = "Statistical Search Results";
                              myheader.printHead(Title,Head,out);
                              out.println("<BR><CENTER><FONT SIZE=3>Distribution of theses on the basis of thesis type</FONT></CENTER><BR>");
                              stmtd=Conn.createStatement();
                              sd="select type,count(type) from thesis group by type";
                              rsetd=stmtd.executeQuery(sd);
                              out.println("<CENTER><TABLE BORDER=3 CELLPADDING=5 BGCOLOR='"+Config.tablecolor+"'>");
                              out.println("<TR><FONT SIZE=4><TD><CENTER>Thesis type</CENTER></TD><TD><CENTER>Number of Theses</CENTER></TD></FONT></TR>");
                              while(rsetd.next()){
                                    String name=rsetd.getString(1);
                                    int noTheses=rsetd.getInt(2);
                                    out.println("<TR><TD align=CENTER>");
                                    myheader.printStat(out);
                                    out.println("<INPUT TYPE=SUBMIT VALUE="+name+"><INPUT TYPE=HIDDEN NAME=type VALUE="+name+"><INPUT TYPE=HIDDEN NAME=form_no VALUE=22></FORM></TD><TD><CENTER>"+noTheses+"</CENTER></TD></TR>"); 
                              } 
                              out.println("</TABLE></CENTER>");
                              break;
                        case 5:  //Distribution of Thesis  based on year
                              Title = "Online Thesis Submission";
                              Head = "Statistical Search Results";
                              myheader.printHead(Title,Head,out);
                              out.println("<BR><CENTER><FONT SIZE=3>Distribution of theses on the basis of year</FONT></CENTER><BR>");
                              stmtd=Conn.createStatement();
                              sd="select year,count(year) from thesis group by year";
                              rsetd=stmtd.executeQuery(sd);
                              out.println("<CENTER><TABLE BORDER=3 CELLPADDING=5 BGCOLOR='"+Config.tablecolor+"'>");
                              out.println("<TR><FONT SIZE=4><TD><CENTER>Year</CENTER></TD><TD><CENTER>Number of Theses</CENTER></TD></FONT></TR>");
                              while(rsetd.next()){
                                    String name=rsetd.getString(1);
                                    int noTheses=rsetd.getInt(2);
                                    out.println("<TR><TD align=CENTER>");
                                    myheader.printStat(out);
                                    out.println("<INPUT TYPE=SUBMIT VALUE="+name+"><INPUT TYPE=HIDDEN NAME=year VALUE="+name+"><INPUT TYPE=HIDDEN NAME=form_no VALUE=23></FORM></TD><TD><CENTER>"+noTheses+"</CENTER></TD></TR>"); 
                              } 
                              out.println("</TABLE></CENTER>");
                              break;
                        case 20:
                              try{
                                    stmt=Conn.createStatement();
                                    String login=Req.getParameterValues("guide")[0];
                                    sear= "select students.sroll, students.sname, thesis.title,thesis.keyword1,thesis.keyword2,thesis.keyword3,thesis.keyword4,thesis.filename,thesis.status,thesis.serialno,thesis.abstract,student_thesis.type,students.dno,students.saddress,students.semail,student_faculty.loginid from student_faculty,students, thesis,student_thesis where student_faculty.sroll=students.sroll and student_faculty.loginid='"+login+"' and student_thesis.serialno=thesis.serialno and student_thesis.sroll=students.sroll and student_faculty.type=student_thesis.type";
                                    ResultSet rset1=stmt.executeQuery(sear);
                                    this.gen_form(rset1,out);
                              } catch(SQLException e){}
                              break;
                        case 21:
                              try{
                                    stmt=Conn.createStatement();
                                    String Dept=Req.getParameterValues("dept")[0];
                                    sear= "select students.sroll, students.sname, thesis.title,thesis.keyword1,thesis.keyword2,thesis.keyword3,thesis.keyword4,thesis.filename,thesis.status,thesis.serialno,thesis.abstract,student_thesis.type,students.dno,students.saddress,students.semail,student_faculty.loginid from student_faculty,students, thesis,department,student_thesis where student_faculty.sroll=students.sroll and (department.dno like '%"+Dept+"%' or department.dname like '%"+Dept+"%') and student_thesis.serialno=thesis.serialno and student_thesis.sroll=students.sroll and student_faculty.type=student_thesis.type and students.dno=department.dno";
                                    ResultSet rset1=stmt.executeQuery(sear);
                                    this.gen_form(rset1,out);
                              } catch(SQLException e){}
                              break;
                        case 22:
                              try{
                                    stmt=Conn.createStatement();
                                    String Type=Req.getParameterValues("type")[0];
                                    sear="select students.sroll, students.sname, thesis.title,thesis.keyword1,thesis.keyword2,thesis.keyword3,thesis.keyword4,thesis.filename,thesis.status,thesis.serialno,thesis.abstract,student_thesis.type,students.dno,students.saddress,students.semail,student_faculty.loginid from student_faculty,students, thesis,department,student_thesis where student_faculty.sroll=students.sroll and student_faculty.type like '%"+Type+"%' and student_thesis.serialno=thesis.serialno and student_thesis.sroll=students.sroll and student_faculty.type=student_thesis.type and students.dno=department.dno";
                                    ResultSet rset1=stmt.executeQuery(sear);
                                    this.gen_form(rset1,out);
                              } catch(SQLException e){}
                              break;
                        case 23:
                              try{
                                    stmt=Conn.createStatement();
                                    String Year=Req.getParameterValues("year")[0];
                                    sear="select students.sroll, students.sname, thesis.title,thesis.keyword1,thesis.keyword2,thesis.keyword3,thesis.keyword4,thesis.filename,thesis.status,thesis.serialno,thesis.abstract,student_thesis.type,students.dno,students.saddress,students.semail,student_faculty.loginid from student_faculty,students, thesis,department,student_thesis where student_faculty.sroll=students.sroll and  thesis.year like '%"+Year+"%' and student_thesis.serialno=thesis.serialno and student_thesis.sroll=students.sroll and student_faculty.type=student_thesis.type and students.dno=department.dno";
                                    ResultSet rset1=stmt.executeQuery(sear);
                                    this.gen_form(rset1,out);
                              } catch(SQLException e){}
                              break;
                        case 30:
                              this.printStudentInfo(Req,out,Conn);
                              break;

                  }
                  myheader.printFooter(out);
                  out.println("</BODY></HTML>");
            }catch(FileNotFoundException e){}
            catch(IOException e){}
            catch(SQLException e){}
      }

         /** Method to generate the form
           * @param res ResultSet instance
           * @param out PrintWriter instance
           * @return NOthing
           */
      public void gen_form(ResultSet res,PrintWriter out){
            String actionString="http://"+Config.hostname+":"+Config.port+"/servlet/Stat";
            String Type,sname,dname,file,dir,roll,title,filename,kw1,kw2,kw3,kw4,status,Dno,Addr,Email,Guide;
            String serialno,str1="";
            int i=0;
            Integer i1=new Integer(0);
            Random Myrandom=new Random();
            i=Myrandom.nextInt();
            String Title = "Online Thesis Submission";
            String Head="search results";
            myheader.printHead(Title,Head,out);
            try{
                  while(res.next()){
                        roll=res.getString(1);
                        sname=res.getString(2);
                        title=res.getString(3);
                        kw1=res.getString(4);
                        kw2=res.getString(5);
                        kw3=res.getString(6);
                        kw4=res.getString(7);
                        status=res.getString(9);
                        serialno=res.getString(10);
                        String Abstract=res.getString(11);
                        Type=res.getString(12);
                        Dno=res.getString(13);
                        Addr=res.getString(14);
                        Email=res.getString(15);
                        Guide=res.getString(16);
                        str1+="<HR><CENTER><TABLE>";
                        str1+="<TR><TD>Roll Number</TD><TD><FONT SIZE=5>"+roll+"</FONT></TD></TR>";
                        str1+="<TR><TD>Name</TD><TD><FONT SIZE=5>"+sname+"</FONT></TD></TR>";
                        str1+="<TR><TD>Thesis title</TD><TD><FONT SIZE=5>"+title+"</FONT></TD></TR>";
                        str1+="<TR><TD><FORM METHOD=POST ACTION="+actionString+">";
                        str1+="<input type=hidden name=form_no value=30>";
                        str1+="<input type=hidden name=roll value="+roll+">";
                        str1+="<input type=hidden name=name value="+sname+">";
                        str1+="<input type=hidden name=Type value="+Type+">";
                        str1+="<input type=hidden name=dno value="+Dno+">";
                        str1+="<input type=hidden name=addr value="+Addr+">";
                        str1+="<input type=hidden name=email value="+Email+">";
                        str1+="<input type=hidden name=guide value="+Guide+">";
                        str1+="<input type=hidden name=title value=\""+title+"\">";
                        str1+="<input type=hidden name=kw1 value=\""+kw1+"\">";
                        str1+="<input type=hidden name=kw2 value=\""+kw2+"\">";
                        str1+="<input type=hidden name=kw3 value=\""+kw3+"\">";
                        str1+="<input type=hidden name=kw4 value=\""+kw4+"\">";
                        str1+="<input type=hidden name=serialno value=\""+serialno+"\">";
                        str1+="<input type=hidden name=Abstract value=\""+Abstract+"\">";
                        str1+="<input type=hidden name=status value=\""+status+"\">";
                        str1+="<font size=5>";
                        str1+="<input type=submit value=\"Information regarding the thesis\">";
                        str1+="</font></form></TD></TR>";
                        str1+="</TABLE></CENTER>";
                  }
            } catch(SQLException e){} 
            out.println(str1);
      }
         /** Method to search for statistics 
           * @param out PrintWriter instance
           * @param req HttpServletRequest instance
           * @return Nothing
           */
      public void search(PrintWriter out, HttpServletRequest req){
            String Dept,Guide,Year,Type;
            try{
                  Statement stmt =Conn.createStatement();
                  Guide=req.getParameterValues("guide")[0];
                  Dept=req.getParameterValues("dept")[0];
                  Year=req.getParameterValues("year")[0];
                  Type=req.getParameterValues("type")[0];
                  String sear="select count(*) from thesis,student_thesis,students,faculty,department,student_faculty where thesis.year like '%"+Year+"%' and thesis.type like '%"+Type+"%' and (faculty.fname like '%"+Guide+"%' or faculty.loginid like '%"+Guide+"%') and (department.dno like '%"+Dept+"%' or department.dname like '%"+Dept+"%') and thesis.serialno=student_thesis.serialno and student_thesis.sroll=students.sroll and student_faculty.sroll=student_thesis.sroll and student_faculty.loginid=faculty.loginid and students.dno=department.dno and student_thesis.type=thesis.type and student_faculty.type=thesis.type"; 
                  ResultSet rset=stmt.executeQuery(sear);
                  rset.next();
                  int val=rset.getInt(1);
                  String name="Given search";
                  out.println(name+": "+val+"<BR>"); 
            } catch(SQLException e){}
      }
         /** Method to print types list 
           * @param out PrintWriter instance
           * @param Conn Connection instance
           * @return Nothing
           */
      public void printTypesList(PrintWriter out,Connection Conn){
            String s="";
            try{
                  Statement Stmt=Conn.createStatement();
                  String Query="select * from types";
                  ResultSet types=Stmt.executeQuery(Query);
                  s+="<TR><TD><FONT SIZE=5>Type of Thesis</FONT></TD><TD><FONT SIZE=5><SELECT NAME=type>";
                  s+="<OPTION VALUE=\"\">Choose one";  
                  while(types.next()){
                        s+="<option value="+types.getString(1)+">"+types.getString(1).toUpperCase();
                  }
                  s+="</select></font></td></tr>";
                  out.println(s);
            }catch(SQLException e){}
      }
         /** Method to print pertinent student informations
           * @param req HttpServletRequest instance
           * @param out PrintWriter instance
           * @param Conn Connection instance
           * @return Nothing
           */
      public void printStudentInfo(HttpServletRequest req,PrintWriter out,Connection Conn){
            try{
                  String dno="",year="",serialno="";
                  String thesisDir=Config.thesissite;
                  Statement Stmt=Conn.createStatement();
                  String actionString="http://"+Config.hostname;
                  actionString+=":"+Config.port+"/servlet/Main";
                  String Title = "Online Thesis Submission";
                  String Head = "Information about the thesis";
                  myheader.printHead(Title,Head,out);
                  String roll=req.getParameterValues("roll")[0];
                  String type=req.getParameterValues("Type")[0];
                  dno= req.getParameterValues("dno")[0];
                  String Stg="";
                  Stg="select serialno from student_thesis where sroll='"+roll+"'and type='"+type+"'";
                  ResultSet Result=Stmt.executeQuery(Stg);
                  if(Result.next()){
                        serialno=Result.getString(1);
                  }
                  Stg="select year from thesis where serialno='"+serialno+"'";
                  ResultSet Year=Stmt.executeQuery(Stg); 
                  if(Year.next()){
                        year=Year.getString(1);
                  }	
                  String str1="<form method=post action="+actionString+">";
                  str1+="<center>";
                  str1+="<TABLE>";
                  str1+="<tr><TD><FONT SIZE=5>Name    </FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("name")[0]+"</FONT></TD></TR>";
                  str1+="<tr><TD><FONT SIZE=5>Roll No   </FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("roll")[0]+"</FONT></TD></TR>";
                  str1+="<tr><TD><FONT SIZE=5>Department</FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("dno")[0]+"</FONT></TD></TR>";
                  str1+="<tr><TD><FONT SIZE=5>Email     </FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("email")[0]+"</FONT></TD></TR>";
                  str1+="<tr><TD><FONT SIZE=5>Address   </FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("addr")[0]+"</FONT></TD></TR>";
                  str1+="<tr><TD><FONT SIZE=5>Name of Guide</FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("guide")[0]+"</FONT></TD></TR>";
                  str1+="<tr><TD><FONT SIZE=5>Thesis Type </FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("Type")[0]+"</FONT></TD></TR>";
                  str1+="<tr><TD><FONT SIZE=5>Title of Thesis </FONT></TD><TD><FONT SIZE=5>"+req.getParameterValues("title")[0]+"</FONT></TD></TR>";
                  str1+="<tr><TD><FONT SIZE=5>";
                  str1+="</TABLE>";
                  str1+="<FONT SIZE=5>";
                  str1+="<br> Key words : "+req.getParameterValues("kw1")[0]+","+req.getParameterValues("kw2")[0]+","+req.getParameterValues("kw3")[0]+","+req.getParameterValues("kw4")[0];
                  String file=thesisDir+"/"+dno+"/"+year+"/"+type+"/"+roll+".html";
                  str1+="<br><a href=\""+file+"\"> Thesis</a><br>";
                  str1+="<input type=hidden name=form_no value=6>";
                  str1+="<input type=hidden name=serialno value="+req.getParameterValues("serialno")[0]+">";
                  str1+="<u>Abstract of the thesis</u><br>"+req.getParameterValues("Abstract")[0]+"<br>";
                  String status=req.getParameterValues("status")[0];
                  if(status.compareTo("y") != 0){
                        str1+="<p>The thesis has not been approved";
                  }
                  else{
                        str1+="<p>The thesis has been approved.";
                  }
                  str1+="</font></center></form>";
                  out.println(str1);
                  out.println("</body></html>");
            } catch(SQLException e){}
      }
}
