create table department ( 
            constraint pk_department primary key (dno), 
            dno varchar(10) not null, 
            dname varchar(60)
);
create table students ( 
            constraint pk_student primary key (sroll), 
            constraint fk_studdno foreign key (dno) references department,
            sroll varchar(10) not null, 
            sname varchar(30), 
            dno varchar(10), 
            saddress varchar(200), 
            semail varchar(40)
);
create table faculty ( 
            constraint pk_faculty primary key (loginid), 
            constraint fk_facdno foreign key (dno) references department,
            loginid varchar(10)  not null, 
            fname varchar(30), 
            dno varchar(10), 
            femail varchar(40) 
);
create table types ( 
            type varchar(20) primary key  not null
);
create table thesis ( 
            constraint pk_thesis primary key (serialno), 
            constraint fk_thesistype foreign key(type) references types,
            serialno integer not null, 
            title varchar(100), 
            url varchar(100),
            type varchar(20), 
            keyword1 varchar(20), 
            keyword2 varchar(20), 
            keyword3 varchar(20), 
            keyword4 varchar(20), 
            filename varchar(20), 
            year varchar(4), 
            abstract varchar(1000), 
            status   varchar(1)
);
create table auth_table ( 
            constraint pk_auth_table primary key (login), 
            login varchar(10)  not null, 
            password varchar(10), 
            dno varchar(10), 
            type varchar(15)
);
create table student_faculty ( 
            constraint pk_student_faculty primary key (sroll,loginid,type), 
            constraint fk_studroll foreign key (sroll) references students,
            constraint fk_faclogin foreign key (loginid) references faculty,
            constraint fk_thestype foreign key(type) references types,
            constraint fk_faccologin foreign key (co_loginid) references faculty,
            sroll varchar(10)  not null, 
            loginid varchar(10)  not null, 
            type  varchar(10) not null, 
            co_loginid varchar(10)
);
create table student_thesis ( 
            constraint pk_student_thesis primary key (sroll,serialno,type), 
            constraint fk_tslno foreign key (serialno) references thesis,
            constraint fk_sroll foreign key (sroll) references students,
            constraint fk_ttype foreign key(type) references types,
            serialno integer not null , 
            sroll varchar(10)  not null, 
            type varchar(20) not null
);
create table cookies (
            userid varchar(10) not null,
            cookie varchar(8)
);
